/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "gram.y"


/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 1 shift/reduce conflict and 4 reduce/reduce:
 * 
 * 2 reduce/reduce conflicts on:
 *
 *	    *int . func 
 *	    **int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 * 2 reduce/reduce conflicts on:
 *
 *	   &int . func
 *	   &&int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers.
 *	(Of course, you can always enclose an assignment in parens.)
 *      (I can't see any obvious way to use operator precedence to
 *      get rid of this: seems like you'd need to duplicate simpleexpr
 *      with different precedence. --BCM)
 *
 */
int ignorenl;
int notCommand;
int seeComment;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static Expr *
ParseCanonFor (Expr *expr);

static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);


#line 141 "gram.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_GRAM_H_INCLUDED
# define YY_YY_GRAM_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    VAR = 258,                     /* VAR  */
    EXPR = 259,                    /* EXPR  */
    ARRAY = 260,                   /* ARRAY  */
    STRUCT = 261,                  /* STRUCT  */
    UNION = 262,                   /* UNION  */
    ENUM = 263,                    /* ENUM  */
    COMP = 264,                    /* COMP  */
    HASH = 265,                    /* HASH  */
    SEMI = 266,                    /* SEMI  */
    MOD = 267,                     /* MOD  */
    OC = 268,                      /* OC  */
    CC = 269,                      /* CC  */
    DOLLAR = 270,                  /* DOLLAR  */
    DOTDOTDOT = 271,               /* DOTDOTDOT  */
    ENDFILE = 272,                 /* ENDFILE  */
    GLOBAL = 273,                  /* GLOBAL  */
    AUTO = 274,                    /* AUTO  */
    STATIC = 275,                  /* STATIC  */
    CONST = 276,                   /* CONST  */
    POLY = 277,                    /* POLY  */
    INTEGER = 278,                 /* INTEGER  */
    NATURAL = 279,                 /* NATURAL  */
    RATIONAL = 280,                /* RATIONAL  */
    REAL = 281,                    /* REAL  */
    STRING = 282,                  /* STRING  */
    FOREIGN = 283,                 /* FOREIGN  */
    FILET = 284,                   /* FILET  */
    MUTEX = 285,                   /* MUTEX  */
    SEMAPHORE = 286,               /* SEMAPHORE  */
    CONTINUATION = 287,            /* CONTINUATION  */
    THREAD = 288,                  /* THREAD  */
    VOID = 289,                    /* VOID  */
    BOOL = 290,                    /* BOOL  */
    FUNCTION = 291,                /* FUNCTION  */
    FUNC = 292,                    /* FUNC  */
    EXCEPTION = 293,               /* EXCEPTION  */
    RAISE = 294,                   /* RAISE  */
    TYPEDEF = 295,                 /* TYPEDEF  */
    IMPORT = 296,                  /* IMPORT  */
    NEW = 297,                     /* NEW  */
    ANONINIT = 298,                /* ANONINIT  */
    NAMESPACE = 299,               /* NAMESPACE  */
    PUBLIC = 300,                  /* PUBLIC  */
    PROTECTED = 301,               /* PROTECTED  */
    EXTEND = 302,                  /* EXTEND  */
    WHILE = 303,                   /* WHILE  */
    DO = 304,                      /* DO  */
    FOR = 305,                     /* FOR  */
    SWITCH = 306,                  /* SWITCH  */
    BREAK = 307,                   /* BREAK  */
    CONTINUE = 308,                /* CONTINUE  */
    RETURNTOK = 309,               /* RETURNTOK  */
    FORK = 310,                    /* FORK  */
    CASE = 311,                    /* CASE  */
    DEFAULT = 312,                 /* DEFAULT  */
    TWIXT = 313,                   /* TWIXT  */
    NAME = 314,                    /* NAME  */
    TYPENAME = 315,                /* TYPENAME  */
    NAMESPACENAME = 316,           /* NAMESPACENAME  */
    COMMAND = 317,                 /* COMMAND  */
    NAMECOMMAND = 318,             /* NAMECOMMAND  */
    TEN_NUM = 319,                 /* TEN_NUM  */
    OCTAL0_NUM = 320,              /* OCTAL0_NUM  */
    OCTAL_NUM = 321,               /* OCTAL_NUM  */
    BINARY_NUM = 322,              /* BINARY_NUM  */
    HEX_NUM = 323,                 /* HEX_NUM  */
    TEN_FLOAT = 324,               /* TEN_FLOAT  */
    OCTAL0_FLOAT = 325,            /* OCTAL0_FLOAT  */
    OCTAL_FLOAT = 326,             /* OCTAL_FLOAT  */
    BINARY_FLOAT = 327,            /* BINARY_FLOAT  */
    HEX_FLOAT = 328,               /* HEX_FLOAT  */
    CHAR_CONST = 329,              /* CHAR_CONST  */
    STRING_CONST = 330,            /* STRING_CONST  */
    POLY_CONST = 331,              /* POLY_CONST  */
    THREAD_CONST = 332,            /* THREAD_CONST  */
    COMMENT_CONST = 333,           /* COMMENT_CONST  */
    VOIDVAL = 334,                 /* VOIDVAL  */
    BOOLVAL = 335,                 /* BOOLVAL  */
    DARROW = 336,                  /* DARROW  */
    ISTYPE = 337,                  /* ISTYPE  */
    HASMEMBER = 338,               /* HASMEMBER  */
    POUND = 339,                   /* POUND  */
    COMMA = 340,                   /* COMMA  */
    ASSIGN = 341,                  /* ASSIGN  */
    ASSIGNPLUS = 342,              /* ASSIGNPLUS  */
    ASSIGNMINUS = 343,             /* ASSIGNMINUS  */
    ASSIGNTIMES = 344,             /* ASSIGNTIMES  */
    ASSIGNDIVIDE = 345,            /* ASSIGNDIVIDE  */
    ASSIGNDIV = 346,               /* ASSIGNDIV  */
    ASSIGNMOD = 347,               /* ASSIGNMOD  */
    ASSIGNPOW = 348,               /* ASSIGNPOW  */
    ASSIGNSHIFTL = 349,            /* ASSIGNSHIFTL  */
    ASSIGNSHIFTR = 350,            /* ASSIGNSHIFTR  */
    ASSIGNLXOR = 351,              /* ASSIGNLXOR  */
    ASSIGNLAND = 352,              /* ASSIGNLAND  */
    ASSIGNLOR = 353,               /* ASSIGNLOR  */
    ASSIGNOR = 354,                /* ASSIGNOR  */
    ASSIGNAND = 355,               /* ASSIGNAND  */
    QUEST = 356,                   /* QUEST  */
    COLON = 357,                   /* COLON  */
    OR = 358,                      /* OR  */
    AND = 359,                     /* AND  */
    LOR = 360,                     /* LOR  */
    LXOR = 361,                    /* LXOR  */
    LAND = 362,                    /* LAND  */
    EQ = 363,                      /* EQ  */
    NE = 364,                      /* NE  */
    LT = 365,                      /* LT  */
    GT = 366,                      /* GT  */
    LE = 367,                      /* LE  */
    GE = 368,                      /* GE  */
    SHIFTL = 369,                  /* SHIFTL  */
    SHIFTR = 370,                  /* SHIFTR  */
    PLUS = 371,                    /* PLUS  */
    MINUS = 372,                   /* MINUS  */
    TIMES = 373,                   /* TIMES  */
    DIVIDE = 374,                  /* DIVIDE  */
    DIV = 375,                     /* DIV  */
    POW = 376,                     /* POW  */
    STARSTAR = 377,                /* STARSTAR  */
    POW2 = 378,                    /* POW2  */
    POW3 = 379,                    /* POW3  */
    UNIONCAST = 380,               /* UNIONCAST  */
    UMINUS = 381,                  /* UMINUS  */
    BANG = 382,                    /* BANG  */
    FACT = 383,                    /* FACT  */
    LNOT = 384,                    /* LNOT  */
    INC = 385,                     /* INC  */
    DEC = 386,                     /* DEC  */
    STAR = 387,                    /* STAR  */
    AMPER = 388,                   /* AMPER  */
    THREADID = 389,                /* THREADID  */
    OS = 390,                      /* OS  */
    CS = 391,                      /* CS  */
    DOT = 392,                     /* DOT  */
    ARROW = 393,                   /* ARROW  */
    STAROS = 394,                  /* STAROS  */
    CALL = 395,                    /* CALL  */
    OP = 396,                      /* OP  */
    CP = 397,                      /* CP  */
    POINTER = 398,                 /* POINTER  */
    COLONCOLON = 399,              /* COLONCOLON  */
    IF = 400,                      /* IF  */
    TRY = 401,                     /* TRY  */
    NONL = 402,                    /* NONL  */
    ELSE = 403,                    /* ELSE  */
    CATCH = 404,                   /* CATCH  */
    NL = 405                       /* NL  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define VAR 258
#define EXPR 259
#define ARRAY 260
#define STRUCT 261
#define UNION 262
#define ENUM 263
#define COMP 264
#define HASH 265
#define SEMI 266
#define MOD 267
#define OC 268
#define CC 269
#define DOLLAR 270
#define DOTDOTDOT 271
#define ENDFILE 272
#define GLOBAL 273
#define AUTO 274
#define STATIC 275
#define CONST 276
#define POLY 277
#define INTEGER 278
#define NATURAL 279
#define RATIONAL 280
#define REAL 281
#define STRING 282
#define FOREIGN 283
#define FILET 284
#define MUTEX 285
#define SEMAPHORE 286
#define CONTINUATION 287
#define THREAD 288
#define VOID 289
#define BOOL 290
#define FUNCTION 291
#define FUNC 292
#define EXCEPTION 293
#define RAISE 294
#define TYPEDEF 295
#define IMPORT 296
#define NEW 297
#define ANONINIT 298
#define NAMESPACE 299
#define PUBLIC 300
#define PROTECTED 301
#define EXTEND 302
#define WHILE 303
#define DO 304
#define FOR 305
#define SWITCH 306
#define BREAK 307
#define CONTINUE 308
#define RETURNTOK 309
#define FORK 310
#define CASE 311
#define DEFAULT 312
#define TWIXT 313
#define NAME 314
#define TYPENAME 315
#define NAMESPACENAME 316
#define COMMAND 317
#define NAMECOMMAND 318
#define TEN_NUM 319
#define OCTAL0_NUM 320
#define OCTAL_NUM 321
#define BINARY_NUM 322
#define HEX_NUM 323
#define TEN_FLOAT 324
#define OCTAL0_FLOAT 325
#define OCTAL_FLOAT 326
#define BINARY_FLOAT 327
#define HEX_FLOAT 328
#define CHAR_CONST 329
#define STRING_CONST 330
#define POLY_CONST 331
#define THREAD_CONST 332
#define COMMENT_CONST 333
#define VOIDVAL 334
#define BOOLVAL 335
#define DARROW 336
#define ISTYPE 337
#define HASMEMBER 338
#define POUND 339
#define COMMA 340
#define ASSIGN 341
#define ASSIGNPLUS 342
#define ASSIGNMINUS 343
#define ASSIGNTIMES 344
#define ASSIGNDIVIDE 345
#define ASSIGNDIV 346
#define ASSIGNMOD 347
#define ASSIGNPOW 348
#define ASSIGNSHIFTL 349
#define ASSIGNSHIFTR 350
#define ASSIGNLXOR 351
#define ASSIGNLAND 352
#define ASSIGNLOR 353
#define ASSIGNOR 354
#define ASSIGNAND 355
#define QUEST 356
#define COLON 357
#define OR 358
#define AND 359
#define LOR 360
#define LXOR 361
#define LAND 362
#define EQ 363
#define NE 364
#define LT 365
#define GT 366
#define LE 367
#define GE 368
#define SHIFTL 369
#define SHIFTR 370
#define PLUS 371
#define MINUS 372
#define TIMES 373
#define DIVIDE 374
#define DIV 375
#define POW 376
#define STARSTAR 377
#define POW2 378
#define POW3 379
#define UNIONCAST 380
#define UMINUS 381
#define BANG 382
#define FACT 383
#define LNOT 384
#define INC 385
#define DEC 386
#define STAR 387
#define AMPER 388
#define THREADID 389
#define OS 390
#define CS 391
#define DOT 392
#define ARROW 393
#define STAROS 394
#define CALL 395
#define OP 396
#define CP 397
#define POINTER 398
#define COLONCOLON 399
#define IF 400
#define TRY 401
#define NONL 402
#define ELSE 403
#define CATCH 404
#define NL 405

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 71 "gram.y"

    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;

#line 515 "gram.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;


int yyparse (void);


#endif /* !YY_YY_GRAM_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_VAR = 3,                        /* VAR  */
  YYSYMBOL_EXPR = 4,                       /* EXPR  */
  YYSYMBOL_ARRAY = 5,                      /* ARRAY  */
  YYSYMBOL_STRUCT = 6,                     /* STRUCT  */
  YYSYMBOL_UNION = 7,                      /* UNION  */
  YYSYMBOL_ENUM = 8,                       /* ENUM  */
  YYSYMBOL_COMP = 9,                       /* COMP  */
  YYSYMBOL_HASH = 10,                      /* HASH  */
  YYSYMBOL_SEMI = 11,                      /* SEMI  */
  YYSYMBOL_MOD = 12,                       /* MOD  */
  YYSYMBOL_OC = 13,                        /* OC  */
  YYSYMBOL_CC = 14,                        /* CC  */
  YYSYMBOL_DOLLAR = 15,                    /* DOLLAR  */
  YYSYMBOL_DOTDOTDOT = 16,                 /* DOTDOTDOT  */
  YYSYMBOL_ENDFILE = 17,                   /* ENDFILE  */
  YYSYMBOL_GLOBAL = 18,                    /* GLOBAL  */
  YYSYMBOL_AUTO = 19,                      /* AUTO  */
  YYSYMBOL_STATIC = 20,                    /* STATIC  */
  YYSYMBOL_CONST = 21,                     /* CONST  */
  YYSYMBOL_POLY = 22,                      /* POLY  */
  YYSYMBOL_INTEGER = 23,                   /* INTEGER  */
  YYSYMBOL_NATURAL = 24,                   /* NATURAL  */
  YYSYMBOL_RATIONAL = 25,                  /* RATIONAL  */
  YYSYMBOL_REAL = 26,                      /* REAL  */
  YYSYMBOL_STRING = 27,                    /* STRING  */
  YYSYMBOL_FOREIGN = 28,                   /* FOREIGN  */
  YYSYMBOL_FILET = 29,                     /* FILET  */
  YYSYMBOL_MUTEX = 30,                     /* MUTEX  */
  YYSYMBOL_SEMAPHORE = 31,                 /* SEMAPHORE  */
  YYSYMBOL_CONTINUATION = 32,              /* CONTINUATION  */
  YYSYMBOL_THREAD = 33,                    /* THREAD  */
  YYSYMBOL_VOID = 34,                      /* VOID  */
  YYSYMBOL_BOOL = 35,                      /* BOOL  */
  YYSYMBOL_FUNCTION = 36,                  /* FUNCTION  */
  YYSYMBOL_FUNC = 37,                      /* FUNC  */
  YYSYMBOL_EXCEPTION = 38,                 /* EXCEPTION  */
  YYSYMBOL_RAISE = 39,                     /* RAISE  */
  YYSYMBOL_TYPEDEF = 40,                   /* TYPEDEF  */
  YYSYMBOL_IMPORT = 41,                    /* IMPORT  */
  YYSYMBOL_NEW = 42,                       /* NEW  */
  YYSYMBOL_ANONINIT = 43,                  /* ANONINIT  */
  YYSYMBOL_NAMESPACE = 44,                 /* NAMESPACE  */
  YYSYMBOL_PUBLIC = 45,                    /* PUBLIC  */
  YYSYMBOL_PROTECTED = 46,                 /* PROTECTED  */
  YYSYMBOL_EXTEND = 47,                    /* EXTEND  */
  YYSYMBOL_WHILE = 48,                     /* WHILE  */
  YYSYMBOL_DO = 49,                        /* DO  */
  YYSYMBOL_FOR = 50,                       /* FOR  */
  YYSYMBOL_SWITCH = 51,                    /* SWITCH  */
  YYSYMBOL_BREAK = 52,                     /* BREAK  */
  YYSYMBOL_CONTINUE = 53,                  /* CONTINUE  */
  YYSYMBOL_RETURNTOK = 54,                 /* RETURNTOK  */
  YYSYMBOL_FORK = 55,                      /* FORK  */
  YYSYMBOL_CASE = 56,                      /* CASE  */
  YYSYMBOL_DEFAULT = 57,                   /* DEFAULT  */
  YYSYMBOL_TWIXT = 58,                     /* TWIXT  */
  YYSYMBOL_NAME = 59,                      /* NAME  */
  YYSYMBOL_TYPENAME = 60,                  /* TYPENAME  */
  YYSYMBOL_NAMESPACENAME = 61,             /* NAMESPACENAME  */
  YYSYMBOL_COMMAND = 62,                   /* COMMAND  */
  YYSYMBOL_NAMECOMMAND = 63,               /* NAMECOMMAND  */
  YYSYMBOL_TEN_NUM = 64,                   /* TEN_NUM  */
  YYSYMBOL_OCTAL0_NUM = 65,                /* OCTAL0_NUM  */
  YYSYMBOL_OCTAL_NUM = 66,                 /* OCTAL_NUM  */
  YYSYMBOL_BINARY_NUM = 67,                /* BINARY_NUM  */
  YYSYMBOL_HEX_NUM = 68,                   /* HEX_NUM  */
  YYSYMBOL_TEN_FLOAT = 69,                 /* TEN_FLOAT  */
  YYSYMBOL_OCTAL0_FLOAT = 70,              /* OCTAL0_FLOAT  */
  YYSYMBOL_OCTAL_FLOAT = 71,               /* OCTAL_FLOAT  */
  YYSYMBOL_BINARY_FLOAT = 72,              /* BINARY_FLOAT  */
  YYSYMBOL_HEX_FLOAT = 73,                 /* HEX_FLOAT  */
  YYSYMBOL_CHAR_CONST = 74,                /* CHAR_CONST  */
  YYSYMBOL_STRING_CONST = 75,              /* STRING_CONST  */
  YYSYMBOL_POLY_CONST = 76,                /* POLY_CONST  */
  YYSYMBOL_THREAD_CONST = 77,              /* THREAD_CONST  */
  YYSYMBOL_COMMENT_CONST = 78,             /* COMMENT_CONST  */
  YYSYMBOL_VOIDVAL = 79,                   /* VOIDVAL  */
  YYSYMBOL_BOOLVAL = 80,                   /* BOOLVAL  */
  YYSYMBOL_DARROW = 81,                    /* DARROW  */
  YYSYMBOL_ISTYPE = 82,                    /* ISTYPE  */
  YYSYMBOL_HASMEMBER = 83,                 /* HASMEMBER  */
  YYSYMBOL_POUND = 84,                     /* POUND  */
  YYSYMBOL_COMMA = 85,                     /* COMMA  */
  YYSYMBOL_ASSIGN = 86,                    /* ASSIGN  */
  YYSYMBOL_ASSIGNPLUS = 87,                /* ASSIGNPLUS  */
  YYSYMBOL_ASSIGNMINUS = 88,               /* ASSIGNMINUS  */
  YYSYMBOL_ASSIGNTIMES = 89,               /* ASSIGNTIMES  */
  YYSYMBOL_ASSIGNDIVIDE = 90,              /* ASSIGNDIVIDE  */
  YYSYMBOL_ASSIGNDIV = 91,                 /* ASSIGNDIV  */
  YYSYMBOL_ASSIGNMOD = 92,                 /* ASSIGNMOD  */
  YYSYMBOL_ASSIGNPOW = 93,                 /* ASSIGNPOW  */
  YYSYMBOL_ASSIGNSHIFTL = 94,              /* ASSIGNSHIFTL  */
  YYSYMBOL_ASSIGNSHIFTR = 95,              /* ASSIGNSHIFTR  */
  YYSYMBOL_ASSIGNLXOR = 96,                /* ASSIGNLXOR  */
  YYSYMBOL_ASSIGNLAND = 97,                /* ASSIGNLAND  */
  YYSYMBOL_ASSIGNLOR = 98,                 /* ASSIGNLOR  */
  YYSYMBOL_ASSIGNOR = 99,                  /* ASSIGNOR  */
  YYSYMBOL_ASSIGNAND = 100,                /* ASSIGNAND  */
  YYSYMBOL_QUEST = 101,                    /* QUEST  */
  YYSYMBOL_COLON = 102,                    /* COLON  */
  YYSYMBOL_OR = 103,                       /* OR  */
  YYSYMBOL_AND = 104,                      /* AND  */
  YYSYMBOL_LOR = 105,                      /* LOR  */
  YYSYMBOL_LXOR = 106,                     /* LXOR  */
  YYSYMBOL_LAND = 107,                     /* LAND  */
  YYSYMBOL_EQ = 108,                       /* EQ  */
  YYSYMBOL_NE = 109,                       /* NE  */
  YYSYMBOL_LT = 110,                       /* LT  */
  YYSYMBOL_GT = 111,                       /* GT  */
  YYSYMBOL_LE = 112,                       /* LE  */
  YYSYMBOL_GE = 113,                       /* GE  */
  YYSYMBOL_SHIFTL = 114,                   /* SHIFTL  */
  YYSYMBOL_SHIFTR = 115,                   /* SHIFTR  */
  YYSYMBOL_PLUS = 116,                     /* PLUS  */
  YYSYMBOL_MINUS = 117,                    /* MINUS  */
  YYSYMBOL_TIMES = 118,                    /* TIMES  */
  YYSYMBOL_DIVIDE = 119,                   /* DIVIDE  */
  YYSYMBOL_DIV = 120,                      /* DIV  */
  YYSYMBOL_POW = 121,                      /* POW  */
  YYSYMBOL_STARSTAR = 122,                 /* STARSTAR  */
  YYSYMBOL_POW2 = 123,                     /* POW2  */
  YYSYMBOL_POW3 = 124,                     /* POW3  */
  YYSYMBOL_UNIONCAST = 125,                /* UNIONCAST  */
  YYSYMBOL_UMINUS = 126,                   /* UMINUS  */
  YYSYMBOL_BANG = 127,                     /* BANG  */
  YYSYMBOL_FACT = 128,                     /* FACT  */
  YYSYMBOL_LNOT = 129,                     /* LNOT  */
  YYSYMBOL_INC = 130,                      /* INC  */
  YYSYMBOL_DEC = 131,                      /* DEC  */
  YYSYMBOL_STAR = 132,                     /* STAR  */
  YYSYMBOL_AMPER = 133,                    /* AMPER  */
  YYSYMBOL_THREADID = 134,                 /* THREADID  */
  YYSYMBOL_OS = 135,                       /* OS  */
  YYSYMBOL_CS = 136,                       /* CS  */
  YYSYMBOL_DOT = 137,                      /* DOT  */
  YYSYMBOL_ARROW = 138,                    /* ARROW  */
  YYSYMBOL_STAROS = 139,                   /* STAROS  */
  YYSYMBOL_CALL = 140,                     /* CALL  */
  YYSYMBOL_OP = 141,                       /* OP  */
  YYSYMBOL_CP = 142,                       /* CP  */
  YYSYMBOL_POINTER = 143,                  /* POINTER  */
  YYSYMBOL_COLONCOLON = 144,               /* COLONCOLON  */
  YYSYMBOL_IF = 145,                       /* IF  */
  YYSYMBOL_TRY = 146,                      /* TRY  */
  YYSYMBOL_NONL = 147,                     /* NONL  */
  YYSYMBOL_ELSE = 148,                     /* ELSE  */
  YYSYMBOL_CATCH = 149,                    /* CATCH  */
  YYSYMBOL_NL = 150,                       /* NL  */
  YYSYMBOL_YYACCEPT = 151,                 /* $accept  */
  YYSYMBOL_lines = 152,                    /* lines  */
  YYSYMBOL_pcommand = 153,                 /* pcommand  */
  YYSYMBOL_eend = 154,                     /* eend  */
  YYSYMBOL_ignorenl = 155,                 /* ignorenl  */
  YYSYMBOL_attendnl = 156,                 /* attendnl  */
  YYSYMBOL_reset = 157,                    /* reset  */
  YYSYMBOL_not_command = 158,              /* not_command  */
  YYSYMBOL_opt_nl = 159,                   /* opt_nl  */
  YYSYMBOL_opt_semi = 160,                 /* opt_semi  */
  YYSYMBOL_opt_comma = 161,                /* opt_comma  */
  YYSYMBOL_command = 162,                  /* command  */
  YYSYMBOL_opt_rawnames = 163,             /* opt_rawnames  */
  YYSYMBOL_rawnames = 164,                 /* rawnames  */
  YYSYMBOL_rawname = 165,                  /* rawname  */
  YYSYMBOL_rawatom = 166,                  /* rawatom  */
  YYSYMBOL_rawnamespace = 167,             /* rawnamespace  */
  YYSYMBOL_fulltype = 168,                 /* fulltype  */
  YYSYMBOL_fullname = 169,                 /* fullname  */
  YYSYMBOL_fullnames = 170,                /* fullnames  */
  YYSYMBOL_namespace = 171,                /* namespace  */
  YYSYMBOL_namespacename = 172,            /* namespacename  */
  YYSYMBOL_namespace_start = 173,          /* namespace_start  */
  YYSYMBOL_namespace_end = 174,            /* namespace_end  */
  YYSYMBOL_block = 175,                    /* block  */
  YYSYMBOL_block_start = 176,              /* block_start  */
  YYSYMBOL_block_end = 177,                /* block_end  */
  YYSYMBOL_statements = 178,               /* statements  */
  YYSYMBOL_if_statement = 179,             /* if_statement  */
  YYSYMBOL_statement = 180,                /* statement  */
  YYSYMBOL_simple_statement = 181,         /* simple_statement  */
  YYSYMBOL_182_1 = 182,                    /* $@1  */
  YYSYMBOL_for_exprs = 183,                /* for_exprs  */
  YYSYMBOL_try_body_statement = 184,       /* try_body_statement  */
  YYSYMBOL_try_statement = 185,            /* try_statement  */
  YYSYMBOL_catches = 186,                  /* catches  */
  YYSYMBOL_catch = 187,                    /* catch  */
  YYSYMBOL_opt_func_body = 188,            /* opt_func_body  */
  YYSYMBOL_func_body = 189,                /* func_body  */
  YYSYMBOL_190_2 = 190,                    /* $@2  */
  YYSYMBOL_block_or_expr = 191,            /* block_or_expr  */
  YYSYMBOL_union_or_enum = 192,            /* union_or_enum  */
  YYSYMBOL_see_comment = 193,              /* see_comment  */
  YYSYMBOL_doc_string = 194,               /* doc_string  */
  YYSYMBOL_opt_comment = 195,              /* opt_comment  */
  YYSYMBOL_case_block = 196,               /* case_block  */
  YYSYMBOL_cases = 197,                    /* cases  */
  YYSYMBOL_case = 198,                     /* case  */
  YYSYMBOL_union_case_block = 199,         /* union_case_block  */
  YYSYMBOL_union_cases = 200,              /* union_cases  */
  YYSYMBOL_union_case = 201,               /* union_case  */
  YYSYMBOL_opt_name = 202,                 /* opt_name  */
  YYSYMBOL_atoms = 203,                    /* atoms  */
  YYSYMBOL_typenames = 204,                /* typenames  */
  YYSYMBOL_typename = 205,                 /* typename  */
  YYSYMBOL_initnames = 206,                /* initnames  */
  YYSYMBOL_name = 207,                     /* name  */
  YYSYMBOL_next_decl = 208,                /* next_decl  */
  YYSYMBOL_func_decl = 209,                /* func_decl  */
  YYSYMBOL_func_name = 210,                /* func_name  */
  YYSYMBOL_opt_init = 211,                 /* opt_init  */
  YYSYMBOL_decl = 212,                     /* decl  */
  YYSYMBOL_subscripts = 213,               /* subscripts  */
  YYSYMBOL_type = 214,                     /* type  */
  YYSYMBOL_subtype = 215,                  /* subtype  */
  YYSYMBOL_opt_type = 216,                 /* opt_type  */
  YYSYMBOL_basetype = 217,                 /* basetype  */
  YYSYMBOL_opt_stars = 218,                /* opt_stars  */
  YYSYMBOL_stars = 219,                    /* stars  */
  YYSYMBOL_dotdotdots = 220,               /* dotdotdots  */
  YYSYMBOL_dims = 221,                     /* dims  */
  YYSYMBOL_struct_members = 222,           /* struct_members  */
  YYSYMBOL_union_members = 223,            /* union_members  */
  YYSYMBOL_opt_class = 224,                /* opt_class  */
  YYSYMBOL_class = 225,                    /* class  */
  YYSYMBOL_opt_publish = 226,              /* opt_publish  */
  YYSYMBOL_publish = 227,                  /* publish  */
  YYSYMBOL_publish_extend = 228,           /* publish_extend  */
  YYSYMBOL_opt_argdecls = 229,             /* opt_argdecls  */
  YYSYMBOL_argdecls = 230,                 /* argdecls  */
  YYSYMBOL_argdecl = 231,                  /* argdecl  */
  YYSYMBOL_args = 232,                     /* args  */
  YYSYMBOL_opt_argdefines = 233,           /* opt_argdefines  */
  YYSYMBOL_argdefines = 234,               /* argdefines  */
  YYSYMBOL_argdefine = 235,                /* argdefine  */
  YYSYMBOL_opt_dotdotdot = 236,            /* opt_dotdotdot  */
  YYSYMBOL_opt_expr = 237,                 /* opt_expr  */
  YYSYMBOL_expr = 238,                     /* expr  */
  YYSYMBOL_comma_expr = 239,               /* comma_expr  */
  YYSYMBOL_opt_exprs = 240,                /* opt_exprs  */
  YYSYMBOL_exprs = 241,                    /* exprs  */
  YYSYMBOL_opt_actuals = 242,              /* opt_actuals  */
  YYSYMBOL_actuals = 243,                  /* actuals  */
  YYSYMBOL_func_right = 244,               /* func_right  */
  YYSYMBOL_245_3 = 245,                    /* $@3  */
  YYSYMBOL_simpleexpr = 246,               /* simpleexpr  */
  YYSYMBOL_opt_integer = 247,              /* opt_integer  */
  YYSYMBOL_assignop = 248,                 /* assignop  */
  YYSYMBOL_integer = 249,                  /* integer  */
  YYSYMBOL_opt_arrayinit = 250,            /* opt_arrayinit  */
  YYSYMBOL_arrayinit = 251,                /* arrayinit  */
  YYSYMBOL_comprehension = 252,            /* comprehension  */
  YYSYMBOL_compnames = 253,                /* compnames  */
  YYSYMBOL_compname = 254,                 /* compname  */
  YYSYMBOL_comparray = 255,                /* comparray  */
  YYSYMBOL_arrayelts = 256,                /* arrayelts  */
  YYSYMBOL_arrayelt = 257,                 /* arrayelt  */
  YYSYMBOL_opt_hashinit = 258,             /* opt_hashinit  */
  YYSYMBOL_hashinit = 259,                 /* hashinit  */
  YYSYMBOL_hashelts = 260,                 /* hashelts  */
  YYSYMBOL_hashelt = 261,                  /* hashelt  */
  YYSYMBOL_hashvalue = 262,                /* hashvalue  */
  YYSYMBOL_structinit = 263,               /* structinit  */
  YYSYMBOL_structelts = 264,               /* structelts  */
  YYSYMBOL_structelt = 265,                /* structelt  */
  YYSYMBOL_init = 266                      /* init  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   5090

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  151
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  116
/* YYNRULES -- Number of rules.  */
#define YYNRULES  348
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  684

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   405


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   190,   190,   191,   193,   194,   196,   198,   200,   209,
     212,   215,   233,   235,   236,   238,   239,   241,   242,   247,
     263,   279,   292,   316,   341,   342,   344,   346,   348,   350,
     353,   356,   357,   358,   360,   363,   365,   370,   376,   381,
     387,   391,   396,   419,   443,   444,   450,   453,   455,   458,
     460,   462,   465,   467,   469,   472,   473,   476,   478,   480,
     482,   487,   489,   491,   493,   495,   497,   499,   501,   528,
     543,   545,   554,   564,   563,   618,   658,   660,   666,   668,
     672,   673,   676,   680,   683,   685,   691,   692,   695,   695,
     697,   699,   706,   707,   710,   712,   715,   717,   719,   722,
     725,   727,   729,   732,   735,   738,   740,   755,   758,   766,
     771,   773,   776,   778,   781,   782,   792,   802,   813,   825,
     831,   864,   866,   868,   876,   878,   881,   886,   888,   890,
     896,   898,   900,   902,   904,   907,   909,   937,   939,   941,
     943,   945,   956,   957,   983,  1009,  1030,  1032,  1035,  1037,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,  1046,  1047,  1048,
    1049,  1050,  1051,  1053,  1055,  1057,  1059,  1062,  1064,  1067,
    1069,  1075,  1078,  1080,  1083,  1088,  1090,  1092,  1093,  1094,
    1095,  1097,  1099,  1102,  1103,  1105,  1106,  1112,  1114,  1117,
    1119,  1122,  1128,  1139,  1142,  1167,  1170,  1172,  1175,  1177,
    1180,  1183,  1189,  1191,  1193,  1194,  1210,  1211,  1217,  1219,
    1221,  1223,  1226,  1228,  1230,  1232,  1238,  1244,  1244,  1249,
    1275,  1280,  1291,  1293,  1295,  1297,  1301,  1303,  1305,  1307,
    1313,  1315,  1317,  1319,  1321,  1323,  1325,  1327,  1329,  1331,
    1333,  1335,  1341,  1349,  1357,  1359,  1361,  1363,  1365,  1367,
    1369,  1371,  1373,  1375,  1377,  1379,  1381,  1383,  1385,  1386,
    1388,  1390,  1392,  1394,  1396,  1398,  1400,  1402,  1404,  1406,
    1408,  1410,  1412,  1414,  1418,  1426,  1433,  1442,  1451,  1457,
    1463,  1465,  1467,  1469,  1471,  1473,  1475,  1477,  1483,  1485,
    1487,  1490,  1492,  1493,  1494,  1495,  1496,  1497,  1498,  1499,
    1500,  1501,  1502,  1503,  1504,  1505,  1506,  1507,  1509,  1510,
    1511,  1512,  1513,  1518,  1519,  1522,  1524,  1538,  1543,  1545,
    1547,  1549,  1551,  1560,  1568,  1570,  1573,  1574,  1580,  1581,
    1584,  1586,  1592,  1594,  1597,  1599,  1602,  1603,  1608,  1611,
    1613,  1616,  1618,  1620,  1622,  1625,  1626,  1627,  1628
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "VAR", "EXPR", "ARRAY",
  "STRUCT", "UNION", "ENUM", "COMP", "HASH", "SEMI", "MOD", "OC", "CC",
  "DOLLAR", "DOTDOTDOT", "ENDFILE", "GLOBAL", "AUTO", "STATIC", "CONST",
  "POLY", "INTEGER", "NATURAL", "RATIONAL", "REAL", "STRING", "FOREIGN",
  "FILET", "MUTEX", "SEMAPHORE", "CONTINUATION", "THREAD", "VOID", "BOOL",
  "FUNCTION", "FUNC", "EXCEPTION", "RAISE", "TYPEDEF", "IMPORT", "NEW",
  "ANONINIT", "NAMESPACE", "PUBLIC", "PROTECTED", "EXTEND", "WHILE", "DO",
  "FOR", "SWITCH", "BREAK", "CONTINUE", "RETURNTOK", "FORK", "CASE",
  "DEFAULT", "TWIXT", "NAME", "TYPENAME", "NAMESPACENAME", "COMMAND",
  "NAMECOMMAND", "TEN_NUM", "OCTAL0_NUM", "OCTAL_NUM", "BINARY_NUM",
  "HEX_NUM", "TEN_FLOAT", "OCTAL0_FLOAT", "OCTAL_FLOAT", "BINARY_FLOAT",
  "HEX_FLOAT", "CHAR_CONST", "STRING_CONST", "POLY_CONST", "THREAD_CONST",
  "COMMENT_CONST", "VOIDVAL", "BOOLVAL", "DARROW", "ISTYPE", "HASMEMBER",
  "POUND", "COMMA", "ASSIGN", "ASSIGNPLUS", "ASSIGNMINUS", "ASSIGNTIMES",
  "ASSIGNDIVIDE", "ASSIGNDIV", "ASSIGNMOD", "ASSIGNPOW", "ASSIGNSHIFTL",
  "ASSIGNSHIFTR", "ASSIGNLXOR", "ASSIGNLAND", "ASSIGNLOR", "ASSIGNOR",
  "ASSIGNAND", "QUEST", "COLON", "OR", "AND", "LOR", "LXOR", "LAND", "EQ",
  "NE", "LT", "GT", "LE", "GE", "SHIFTL", "SHIFTR", "PLUS", "MINUS",
  "TIMES", "DIVIDE", "DIV", "POW", "STARSTAR", "POW2", "POW3", "UNIONCAST",
  "UMINUS", "BANG", "FACT", "LNOT", "INC", "DEC", "STAR", "AMPER",
  "THREADID", "OS", "CS", "DOT", "ARROW", "STAROS", "CALL", "OP", "CP",
  "POINTER", "COLONCOLON", "IF", "TRY", "NONL", "ELSE", "CATCH", "NL",
  "$accept", "lines", "pcommand", "eend", "ignorenl", "attendnl", "reset",
  "not_command", "opt_nl", "opt_semi", "opt_comma", "command",
  "opt_rawnames", "rawnames", "rawname", "rawatom", "rawnamespace",
  "fulltype", "fullname", "fullnames", "namespace", "namespacename",
  "namespace_start", "namespace_end", "block", "block_start", "block_end",
  "statements", "if_statement", "statement", "simple_statement", "$@1",
  "for_exprs", "try_body_statement", "try_statement", "catches", "catch",
  "opt_func_body", "func_body", "$@2", "block_or_expr", "union_or_enum",
  "see_comment", "doc_string", "opt_comment", "case_block", "cases",
  "case", "union_case_block", "union_cases", "union_case", "opt_name",
  "atoms", "typenames", "typename", "initnames", "name", "next_decl",
  "func_decl", "func_name", "opt_init", "decl", "subscripts", "type",
  "subtype", "opt_type", "basetype", "opt_stars", "stars", "dotdotdots",
  "dims", "struct_members", "union_members", "opt_class", "class",
  "opt_publish", "publish", "publish_extend", "opt_argdecls", "argdecls",
  "argdecl", "args", "opt_argdefines", "argdefines", "argdefine",
  "opt_dotdotdot", "opt_expr", "expr", "comma_expr", "opt_exprs", "exprs",
  "opt_actuals", "actuals", "func_right", "$@3", "simpleexpr",
  "opt_integer", "assignop", "integer", "opt_arrayinit", "arrayinit",
  "comprehension", "compnames", "compname", "comparray", "arrayelts",
  "arrayelt", "opt_hashinit", "hashinit", "hashelts", "hashelt",
  "hashvalue", "structinit", "structelts", "structelt", "init", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-571)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-218)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -571,   727,  -571,  -571,  -571,  -571,  -571,  1085,  -571,    10,
      34,    59,    62,  -571,   292,  -571,   292,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,  -571,    94,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,    74,    79,  2120,  3968,  -571,  -571,  -571,
     -37,  3440,     6,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,  -571,  -571,  -571,   -15,    13,  3968,
    3968,  3968,  3968,  3968,  3968,  3968,  3968,  3968,    27,  -571,
    2252,  -571,  -571,  -571,  -571,    63,  -571,  -571,  1221,  -571,
    -571,  -571,  -571,   111,  -571,  -571,    53,    54,   -64,   134,
    -571,  4238,    38,   239,   130,    20,   112,  4678,  -571,  -571,
    -571,  -571,  4094,  4134,   143,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,   146,    68,   116,  -571,  -571,  -571,
    -571,  -571,  -571,    59,    62,   152,   147,   202,  -571,     1,
    4731,  -571,  -571,  -571,  -571,  4334,  -571,  -571,   155,    69,
    3968,  3968,  -571,   237,  -571,   237,   237,  -571,   237,  -571,
     237,   237,   237,   237,   237,  -571,  3572,   100,    64,   105,
    -571,  1357,  -571,   109,  -571,  -571,   949,   244,  -571,   114,
    -571,  -571,   183,   251,  -571,   206,   126,  -571,   184,  4238,
     212,  -571,  -571,  2780,  2015,  -571,   -64,  -571,   -37,  4238,
    4238,  4238,  4238,  4238,    80,   158,   114,  -571,  -571,  -571,
    4238,  -571,  -571,  -571,  2516,   125,  3968,  3968,  -571,  -571,
    -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  3968,  3968,  3968,  3968,  3968,  3968,  3968,
    3968,  3968,  3968,  3968,  3968,  3968,  3968,  3968,  3968,  3968,
    3968,  3968,  3968,  -571,  -571,  -571,  -571,  -571,  3968,   217,
     219,  3968,  1757,  3968,   143,   267,   143,   271,   201,   277,
     153,  1889,   154,  1493,   159,   165,  -571,  -571,   168,   310,
    3968,   310,  -571,  -571,  -571,  -571,   169,  4391,  4448,  3440,
      -1,   -49,   190,  4505,  -571,   269,   316,  -571,   191,  1221,
    -571,  -571,  -571,   319,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -571,   321,  2055,   198,   203,  -571,  3704,
     257,  -571,  -571,  -571,    15,   207,   260,   -48,   211,  -571,
     -16,   221,    17,  -571,   224,  -571,  -571,  -571,  -571,   -68,
     109,  -571,   311,  4198,    94,   114,   122,  -571,  -571,  4678,
     166,  4561,  4787,  4840,  4876,  4911,  4949,  1060,  1060,  1192,
    1192,  1192,  1192,   200,   200,   302,   302,   166,   166,   166,
     166,   233,  -571,  -571,   241,   231,  -571,  4277,  4678,   370,
    -571,   374,  -571,   143,  -571,  -571,   246,  2516,   338,  2384,
    2516,  2120,  -571,   240,  -571,   242,  -571,  -571,  4238,   334,
     252,   278,   253,   255,  3968,   256,   386,  2516,   387,   254,
    -571,   261,  -571,   318,  -571,  -571,    11,   347,  -571,    24,
    -571,  -571,  2648,  4678,  -571,  -571,  -571,  -571,  -571,   152,
     -64,   -64,   392,   -64,   -64,  -571,  -571,  -571,  4238,  -571,
    -571,  -571,  -571,  -571,  -571,     7,   398,   326,   -18,   330,
     405,  -571,  -571,  -571,   268,  3968,  -571,  -571,  -571,  3968,
    -571,  4094,  4134,  -571,   408,   281,   286,   293,   417,   294,
     433,  -571,  -571,   -47,   304,  -571,  -571,  -571,  -571,  -571,
    3968,  -571,   305,  -571,    94,  -571,  2516,  3968,  -571,  4238,
    -571,  -571,   362,  3704,    27,   390,  4622,   366,  -571,   367,
    -571,   368,  -571,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,   314,   444,   317,  -571,    87,  -571,   448,    94,  -571,
     447,  -571,  4731,  -571,  -571,  -571,  -571,  1493,  2516,  1493,
    2384,   321,  1625,  -571,  -571,   449,   451,   454,   237,  -571,
    1493,  -571,   329,   805,  -571,  3704,  4678,  -571,  -571,   402,
     388,  3704,  2912,   456,  3044,   459,   -40,   461,  -571,   391,
    -571,   321,  -571,  -571,  -571,  -571,  -571,  -571,  1221,  -571,
     336,  -571,  -571,    26,  -571,   339,  3176,  -571,  -571,  3836,
    -571,  3308,  -571,  -571,   332,   224,   321,  -571,  4678,  -571,
    -571,  -571,   399,  3704,  -571,  4678,  -571,   484,  4622,  -571,
    -571,   362,   390,  -571,  -571,  3968,  -571,  -571,  -571,  -571,
     487,  -571,  -571,  -571,  2516,   400,  -571,    26,  -571,  1493,
    -571,  -571,  -571,  -571,  -571,  1493,  -571,    57,  -571,   369,
     402,  4678,  -571,  -571,  4678,   499,  -571,  -571,  -571,  -571,
     409,   949,  -571,  -571,  -571,  -571,  -571,   321,  -571,   411,
    -571,    57,  -571,    22,  -571,  -571,  -571,  -571,   949,  -571,
    -571,  -571,   455,   949,  -571,  -571,  -571,  3704,  -571,  -571,
    -571,  -571,  -571,  -571,   457,  -571,  -571,   501,  -571,   415,
    -571,   949,  -571,  -571
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       3,     0,     1,    11,    25,    24,     2,   182,     4,     0,
       0,    92,    93,    67,     0,    46,   292,   177,   178,   179,
     180,   150,   151,   152,   153,   154,   162,   155,   156,   157,
     158,   159,   160,   161,     9,     0,   183,   184,   186,     9,
       9,     9,     9,     0,     0,   149,   149,     9,    44,    37,
      45,   209,    35,   259,   261,   260,   262,   263,   264,   266,
     265,   267,   268,   269,   270,   271,   272,     0,     0,   149,
     149,   149,   149,   149,   149,   149,   149,   149,     0,   281,
     149,     9,     9,   147,   258,     0,    39,    56,   182,    47,
      11,    55,    10,     0,    94,    46,     0,    14,   135,     0,
     142,   149,   185,   176,     0,    11,   204,   206,     7,     8,
       6,     5,   149,   149,     0,   308,   310,   309,   311,   312,
     221,    49,   280,   291,     0,     0,     0,    46,    46,    46,
      46,    63,    64,     0,     0,     0,   176,     0,   202,   148,
     234,    46,    43,    11,   208,   211,    11,    26,    29,     0,
     149,   149,   139,   225,   140,   224,   226,   137,   222,   138,
     223,   228,   227,   230,   232,   273,   149,     0,    14,     0,
      46,   182,    36,    45,    38,    47,   182,     0,    10,    14,
      76,     9,    97,    88,     9,     0,   118,   205,   126,     0,
       0,    13,   129,   149,     0,   136,   135,    46,     0,     0,
       0,     0,     0,     0,     0,   148,    14,     9,     9,     9,
     149,   175,     9,    66,   149,     0,   149,   149,   307,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,   149,   242,   243,   229,   231,   233,   149,     0,
       0,   149,   149,   149,     0,     0,     0,     0,   111,     0,
       0,   149,     0,   182,     0,     0,   118,    65,     0,    16,
     149,    16,    35,    31,    33,    32,    30,     0,     0,   166,
     148,     0,     0,   170,   283,     0,   146,   282,     0,   182,
      80,    84,    42,     0,    48,    51,    57,    21,    46,    96,
      95,    87,    47,    86,    10,   149,     0,     0,   121,   149,
     117,   141,   278,   168,   148,     0,   163,     0,     0,   188,
     192,     0,   201,   130,     0,   139,   140,   137,   138,     0,
       0,   128,     0,     0,     0,    14,     0,    11,    19,   207,
     240,     0,   251,   250,   249,   247,   248,   252,   253,   254,
     255,   256,   257,   244,   245,   235,   236,   237,   238,   239,
     241,     0,   289,   290,     0,     0,   212,   201,   219,     0,
     143,     0,   144,     0,   145,   123,     0,   149,     0,   203,
     149,   149,    15,     0,   210,     0,    28,    34,     0,     0,
       0,     0,     0,     0,   149,   278,     0,   149,     0,    82,
      50,     0,    68,     0,    90,    89,   199,     0,   194,   201,
     120,   122,   149,   124,   345,   347,   346,   125,   119,     0,
     135,   135,     0,   135,   135,   191,   187,   200,     0,   190,
       9,    94,   146,    46,   115,    37,     0,   113,     0,    40,
       0,   127,    45,    73,     0,   149,   285,   284,   286,   149,
     215,   149,   149,   110,     0,     0,     0,     0,    79,     0,
       0,    22,    23,     0,     0,    46,   165,    46,    46,   169,
     149,    47,     0,    81,     0,    83,   149,   149,   198,   149,
     197,   348,    44,   149,    46,   281,   326,    18,   325,    18,
     333,    18,   340,   327,   116,   134,   131,   167,   132,   133,
     189,     0,    10,     0,    10,     0,   114,     0,     0,    10,
       0,    20,   246,   214,   171,   173,    70,   182,   149,   182,
     203,     0,   149,   287,   288,   330,     0,   315,   279,   274,
     182,    46,     0,     0,   196,   149,   336,   335,   337,     0,
       0,   149,    17,   201,    17,     0,    17,     0,   193,     0,
      47,     0,    47,    71,   112,    10,    41,    75,   182,    47,
       0,    47,    78,   100,    47,     0,   149,    47,   328,   149,
      47,   149,    47,   313,    53,     0,     0,    91,   341,   342,
     322,   323,   321,   149,   334,   326,   324,     0,     0,   332,
     331,     0,     0,   339,   338,   149,   220,   218,    94,    72,
       0,    10,    47,    10,   149,     0,    47,   100,    10,   182,
     329,   277,   275,   314,   276,   182,    94,   105,    47,     0,
       0,   343,   344,   316,   216,     0,    10,    58,    10,    60,
       0,   182,    98,    99,    61,    47,    54,     0,    46,     0,
      47,   105,    10,     0,   320,    10,    74,    59,   182,   102,
      10,    47,     0,   182,   103,   104,    62,   149,   319,    47,
      69,   101,    77,    85,   109,   107,   318,     0,   108,     0,
     317,   182,    47,   106
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -571,  -571,  -571,  -571,   103,    65,   -79,  -571,  -156,   238,
    -291,  -571,  -571,   236,  -571,  -571,  -571,  -571,   -19,     8,
     469,   -77,    -9,   -74,   -78,  -470,  -570,  -151,  -571,     0,
     353,  -571,     9,  -571,  -571,  -571,  -571,  -571,  -571,  -571,
    -571,  -571,  -571,  -436,  -571,  -571,   -86,  -571,  -571,  -115,
    -571,  -571,  -244,  -416,  -571,   113,  -571,  -571,  -571,  -571,
    -571,   -41,  -182,    -7,  -571,  -100,  -571,  -571,   348,  -571,
    -165,    82,    83,  -571,   -52,  -571,   -36,  -571,    31,   108,
    -571,   -38,   110,    60,  -571,  -374,   -39,    23,  -571,   285,
     272,  -571,    89,  -571,  -571,   -17,  -571,  -571,   541,  -571,
    -379,  -571,   -72,  -571,  -571,  -571,  -542,  -571,    25,  -571,
      12,    14,  -571,  -571,    16,  -295
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     6,   111,   315,   180,     9,     7,   192,   393,
     553,     8,   146,   147,   148,   286,   149,    83,    84,   450,
      85,    86,   121,   303,    87,    88,   304,   175,    89,   176,
      91,   520,   467,   301,    92,   409,   485,   312,   313,   314,
     415,    93,   182,   183,   310,   574,   616,   617,   628,   650,
     651,   679,   269,   446,   447,   187,   188,   429,    94,    95,
     320,    96,   195,   139,    98,    99,   100,   325,   291,   327,
     292,   265,   267,   210,   101,   102,   103,   104,   196,   331,
     332,   441,   316,   418,   419,   439,   468,   177,   106,   143,
     144,   375,   376,   560,   561,   107,   122,   263,   120,   582,
     424,   669,   591,   592,   629,   497,   498,   577,   425,   499,
     500,   547,   426,   501,   502,   503
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      97,   206,   167,   460,   135,   512,   137,    90,   174,   136,
     596,   179,   264,   266,   333,   178,   125,   -27,  -114,   601,
     379,   108,   381,   307,   427,   305,   215,   109,   328,   140,
     105,   213,   517,   437,   145,    15,   401,   432,    97,   135,
     437,   444,   516,   435,   136,   490,   642,   112,   189,   174,
     341,   211,   153,   155,   156,   158,   160,   161,   162,   163,
     164,   573,   152,   154,   279,   157,   159,   281,   138,   189,
    -148,   193,   113,   168,   442,   114,   207,   194,   208,   209,
     664,    97,   614,   615,   211,   131,   184,   402,   433,   185,
     132,  -148,  -114,   371,   205,   533,   374,   602,   189,   564,
     189,  -148,   438,   169,   214,   205,   205,   142,   667,   489,
     345,   481,   186,   648,   649,   189,   627,   189,   272,   273,
     274,   275,    48,   172,   173,   676,   150,   189,   283,   284,
     285,   189,   278,   287,   288,   400,   190,   124,   190,   463,
     172,   340,   127,   128,   129,   130,   444,   516,   408,   293,
     141,   430,   190,    48,   151,    50,   -27,   580,   583,   290,
     110,   298,   181,   165,    97,    17,    18,    19,    20,    97,
     189,   197,   635,   135,   212,    48,   293,   173,   136,   597,
     189,    48,   321,   452,   170,   171,   324,   330,   334,   451,
     647,   190,   335,   336,   337,   338,   339,   216,   548,   349,
     350,   295,   268,   205,   191,   270,   296,    97,   555,   271,
     557,   276,   217,   277,   191,   417,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   414,   347,   412,   479,
     282,   293,   294,   306,   293,   377,   378,   297,   505,   506,
     589,   508,   509,   302,   145,   213,   548,    17,    18,    19,
      20,   309,   311,   145,   191,   317,    97,   318,   454,   453,
     319,   322,   158,   388,   189,   348,   372,  -181,   373,  -181,
    -181,   380,   157,  -181,   308,   382,   383,   406,   252,   253,
     254,   384,    97,   255,   385,   387,   256,   257,   632,   411,
     389,   258,   423,   259,   260,   261,   390,   262,   416,   391,
     342,   343,   344,   397,   217,   346,   247,   248,   249,   250,
     251,   392,   252,   253,   254,   449,   403,   255,   405,   -46,
     256,   257,   407,   410,    15,   258,   448,   259,   260,   261,
     420,   262,   428,   431,   421,   401,   135,   434,   135,   135,
     135,   136,   470,   136,   136,   136,   115,   116,   117,   118,
     119,   264,   266,   436,   255,   440,   135,   256,   257,   456,
     443,   136,   258,   458,   259,   260,   261,   457,   262,   413,
      97,   461,    97,    97,    97,   462,   466,   293,   464,   417,
     471,   473,   472,   474,   475,   477,   476,   478,   480,   422,
      97,   483,   486,   484,   487,   496,   488,   539,   507,   514,
     465,   515,   138,   469,   138,   518,   519,   610,   521,   526,
     249,   250,   251,   527,   252,   253,   254,   528,   530,   255,
     482,   330,   256,   257,   513,   529,   531,   258,   522,   259,
     260,   261,   377,   262,   532,   135,   534,   540,   545,   550,
     136,   552,   554,   556,   205,   205,   558,  -217,   194,   565,
     568,   590,   576,   538,   579,   541,   535,   581,   536,   537,
     543,   586,   437,   600,   593,   604,   546,   605,   612,    97,
     625,   619,   416,   607,   630,   549,   606,   135,   608,   135,
     659,   135,   136,   575,   136,   611,   136,   613,   633,   449,
     618,   636,   641,   621,   126,   653,   622,   671,   624,   542,
     655,   658,   675,   663,   674,   680,   678,   681,   396,   395,
      97,    97,    97,    97,   300,    97,   566,   569,   588,   571,
     682,   643,   585,    97,   546,   595,   665,   598,   638,   572,
     584,   326,   504,   524,   562,   525,   510,   626,   523,   544,
     511,   570,   394,   138,   652,   138,   386,   123,   654,   598,
     578,    97,   595,     0,   595,   594,   599,     0,     0,   661,
     204,   660,   603,   135,     0,   668,   631,   559,   136,   563,
       0,   204,   204,     0,   567,     0,     0,   673,   634,     0,
       0,     0,     0,     0,     0,   677,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    97,   683,     0,
       0,     0,    97,     0,     0,     0,     0,     0,    97,   645,
       0,     0,     0,     0,     0,   646,     0,     0,     0,     0,
     609,     0,     0,     0,    97,     0,     0,   640,     0,   662,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     595,    97,     0,     0,     0,     0,    97,     0,   204,     0,
       0,     0,     0,   204,     0,     0,     0,     0,   204,   204,
     204,   204,   204,     0,    97,     0,   637,     0,   639,   204,
       0,     0,     0,   644,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   656,     0,   657,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   666,     0,     0,
     670,     0,     0,     0,     0,   672,     0,     2,     3,     0,
       0,     0,     0,   -12,   -12,   -12,     0,     0,   -12,   -12,
     -12,     0,   -12,     0,     4,   -12,   -12,   -12,   -12,   -12,
     -12,     0,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,     0,
       0,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,     0,   204,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,   -12,   -12,     0,     0,     0,   -12,   -12,     0,   -12,
     -12,     0,   204,   126,     0,     0,   587,   217,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   -12,     0,     0,   -12,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   -12,   -12,     0,     0,     0,   -12,
       0,     0,     0,     0,   -12,     0,   -12,   -12,   -12,     0,
       0,     0,   -12,     0,   -12,     0,     0,   204,   -12,     0,
       0,     0,   -12,   -12,     0,     0,     0,     5,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   204,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,   252,   253,   254,
     204,   204,   255,     0,     0,   256,   257,     0,     0,     0,
     258,     0,   259,   260,   261,     0,   262,     0,     0,     0,
       0,     0,     0,   126,     0,    10,    11,    12,   204,     0,
      13,    14,    15,   -52,    16,     0,     0,    17,    18,    19,
      20,    21,    22,     0,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,  -149,   126,    35,     0,
       0,     0,     0,     0,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,   -52,   -52,    47,    48,    49,
      50,     0,     0,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,     0,     0,     0,    65,    66,
       0,    67,    68,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    69,     0,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    71,    72,     0,     0,
       0,    73,   217,     0,     0,     0,    74,     0,    75,    76,
      77,     0,     0,     0,    78,     0,    79,     0,     0,     0,
      80,    10,    11,    12,    81,    82,    13,    14,    15,     0,
      16,     0,     0,    17,    18,    19,    20,    21,    22,     0,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,  -149,     0,    35,     0,     0,     0,     0,     0,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,     0,     0,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,     0,     0,     0,    65,    66,     0,    67,    68,     0,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,     0,   252,   253,   254,     0,     0,   255,     0,    69,
     256,   257,    70,     0,     0,   258,     0,   259,   260,   261,
       0,   262,    71,    72,   217,     0,     0,    73,     0,     0,
       0,     0,    74,     0,    75,    76,    77,     0,     0,     0,
      78,     0,    79,     0,     0,     0,    80,    10,    11,    12,
      81,    82,    13,    14,    15,   -52,    16,     0,     0,    17,
      18,    19,    20,    21,    22,     0,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,  -149,     0,
      35,     0,     0,     0,     0,     0,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,     0,     0,    47,
      48,    49,    50,     0,     0,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,     0,     0,     0,
      65,    66,     0,    67,    68,     0,   245,   246,   247,   248,
     249,   250,   251,     0,   252,   253,   254,     0,     0,   255,
       0,     0,   256,   257,     0,    69,     0,   258,    70,   259,
     260,   261,     0,   262,     0,     0,     0,     0,    71,    72,
       0,     0,     0,    73,     0,     0,     0,     0,    74,     0,
      75,    76,    77,     0,     0,     0,    78,     0,    79,     0,
       0,     0,    80,    10,    11,    12,    81,    82,    13,    14,
     299,     0,    16,     0,     0,    17,    18,    19,    20,    21,
      22,     0,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,  -149,     0,    35,     0,     0,     0,
       0,     0,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,     0,     0,    47,    48,    49,    50,     0,
       0,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,     0,     0,     0,    65,    66,     0,    67,
      68,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    69,     0,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    71,    72,     0,     0,     0,    73,
       0,     0,     0,     0,    74,     0,    75,    76,    77,     0,
       0,     0,    78,     0,    79,     0,     0,     0,    80,    10,
      11,    12,    81,    82,    13,    14,    15,     0,    16,     0,
       0,    17,    18,    19,    20,    21,    22,     0,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
    -149,     0,    35,     0,     0,     0,     0,     0,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,     0,
       0,    47,    48,    49,    50,     0,     0,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,     0,
       0,     0,    65,    66,     0,    67,    68,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    69,     0,     0,
      70,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      71,    72,     0,     0,     0,    73,     0,     0,     0,     0,
      74,     0,    75,    76,    77,     0,     0,     0,    78,     0,
      79,    10,   133,   134,    80,     0,     0,    14,    81,    82,
      16,     0,     0,    17,    18,    19,    20,    21,    22,     0,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      36,    37,     0,     0,     0,     0,     0,     0,     0,     0,
      46,     0,     0,     0,    48,    49,    50,     0,     0,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,     0,     0,     0,    65,    66,     0,    67,    68,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    69,
       0,     0,    70,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    71,    72,     0,     0,     0,    73,     0,     0,
       0,     0,    74,     0,    75,    76,    77,     0,     0,     0,
      78,     0,    79,    10,   133,   134,    80,  -203,     0,    14,
       0,     0,    16,     0,     0,     0,     0,     0,     0,    21,
      22,     0,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    46,     0,     0,     0,    48,    49,    50,     0,
       0,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,     0,     0,     0,    65,    66,     0,    67,
      68,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    69,     0,     0,    70,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    71,    72,     0,     0,     0,    73,
       0,     0,     0,     0,    74,     0,    75,    76,    77,     0,
       0,     0,    78,     0,    79,    10,   133,   134,    80,  -213,
       0,    14,     0,     0,    16,     0,     0,     0,     0,     0,
       0,    21,    22,     0,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    46,     0,     0,     0,    48,    49,
      50,     0,     0,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,     0,     0,     0,    65,    66,
       0,    67,    68,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    69,     0,     0,    70,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    71,    72,     0,     0,
       0,    73,     0,     0,     0,     0,    74,     0,    75,    76,
      77,    10,   133,   134,    78,     0,    79,     0,     0,     0,
      80,  -209,     0,     0,     0,     0,     0,    21,    22,     0,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    10,   133,   134,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    49,   198,    21,    22,     0,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    49,   198,     0,     0,   199,
       0,     0,   200,     0,     0,     0,    10,   133,   134,     0,
       0,  -203,    14,   201,     0,    16,     0,   202,    17,    18,
      19,    20,    21,    22,     0,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,   203,   329,     0,   199,
       0,     0,   200,     0,     0,    36,    37,     0,     0,     0,
       0,     0,     0,   201,     0,    46,     0,   202,     0,    48,
      49,    50,     0,     0,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,   203,  -195,     0,    65,
      66,     0,    67,    68,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    69,     0,     0,    70,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    71,    72,     0,
       0,     0,    73,     0,     0,     0,     0,    74,     0,    75,
      76,    77,     0,     0,     0,    78,     0,    79,    10,   133,
     134,    80,     0,     0,    14,    15,     0,    16,     0,     0,
      17,    18,    19,    20,    21,    22,     0,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    36,    37,     0,
       0,     0,     0,     0,     0,     0,     0,    46,     0,     0,
       0,    48,    49,    50,     0,     0,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,     0,     0,
       0,    65,    66,     0,    67,    68,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    69,     0,     0,    70,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    71,
      72,     0,     0,     0,    73,     0,     0,     0,     0,    74,
       0,    75,    76,    77,     0,     0,     0,   166,     0,    79,
      10,   133,   134,    80,     0,     0,    14,     0,     0,    16,
       0,     0,    17,    18,    19,    20,    21,    22,     0,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,  -149,     0,     0,     0,     0,     0,     0,     0,    36,
      37,     0,     0,     0,     0,     0,     0,     0,     0,    46,
       0,     0,     0,    48,    49,    50,     0,     0,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
       0,     0,     0,    65,    66,     0,    67,    68,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    69,     0,
       0,    70,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    71,    72,     0,     0,     0,    73,     0,     0,     0,
       0,    74,     0,    75,    76,    77,     0,     0,     0,    78,
       0,    79,    10,   133,   134,    80,     0,     0,    14,     0,
       0,    16,     0,     0,    17,    18,    19,    20,    21,    22,
       0,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,    37,     0,     0,     0,     0,     0,     0,     0,
       0,    46,     0,     0,     0,    48,    49,    50,     0,     0,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,     0,     0,     0,    65,    66,     0,    67,    68,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      69,     0,     0,    70,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    71,    72,     0,     0,     0,    73,     0,
       0,     0,     0,    74,     0,    75,    76,    77,     0,     0,
       0,    78,     0,    79,    10,   133,   134,    80,     0,     0,
      14,   422,   491,    16,     0,     0,     0,     0,     0,     0,
      21,    22,     0,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    46,     0,     0,     0,   492,    49,    50,
       0,     0,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,     0,     0,     0,    65,    66,   493,
      67,    68,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    69,     0,     0,    70,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    71,    72,     0,     0,     0,
      73,     0,     0,     0,     0,    74,     0,    75,    76,    77,
       0,     0,     0,   494,     0,   495,    10,   133,   134,    80,
       0,     0,    14,     0,     0,    16,   323,     0,     0,     0,
       0,     0,    21,    22,     0,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,    48,
      49,    50,     0,     0,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,     0,     0,     0,    65,
      66,     0,    67,    68,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    69,     0,     0,    70,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    71,   289,     0,
       0,     0,    73,     0,     0,     0,     0,    74,     0,    75,
      76,    77,     0,     0,     0,    78,  -164,    79,    10,   133,
     134,    80,     0,     0,    14,   422,     0,    16,     0,     0,
       0,     0,     0,     0,    21,    22,     0,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,     0,  -149,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    46,     0,     0,
       0,    48,    49,    50,     0,     0,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,     0,     0,
       0,    65,    66,     0,    67,    68,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    69,     0,     0,    70,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    71,
      72,     0,     0,     0,    73,     0,     0,     0,     0,    74,
       0,    75,    76,    77,     0,     0,     0,    78,     0,    79,
      10,   133,   134,    80,     0,     0,    14,     0,     0,    16,
       0,     0,     0,     0,     0,     0,    21,    22,     0,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,  -149,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    46,
       0,     0,     0,    48,    49,    50,     0,     0,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
       0,     0,     0,    65,    66,   493,    67,    68,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    69,     0,
       0,    70,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    71,    72,     0,     0,     0,    73,     0,     0,     0,
       0,    74,     0,    75,    76,    77,     0,     0,     0,    78,
       0,    79,    10,   133,   134,    80,     0,     0,    14,     0,
     620,    16,     0,     0,     0,     0,     0,     0,    21,    22,
       0,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    46,     0,     0,     0,    48,    49,    50,     0,     0,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,     0,     0,     0,    65,    66,   493,    67,    68,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      69,     0,     0,    70,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    71,    72,     0,     0,     0,    73,     0,
       0,     0,     0,    74,     0,    75,    76,    77,     0,     0,
       0,    78,     0,    79,    10,   133,   134,    80,     0,     0,
      14,   422,   623,    16,     0,     0,     0,     0,     0,     0,
      21,    22,     0,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    46,     0,     0,     0,    48,    49,    50,
       0,     0,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,     0,     0,     0,    65,    66,     0,
      67,    68,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    69,     0,     0,    70,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    71,    72,     0,     0,     0,
      73,     0,     0,     0,     0,    74,     0,    75,    76,    77,
       0,     0,     0,   494,     0,    79,    10,   133,   134,    80,
       0,     0,    14,     0,     0,    16,     0,     0,     0,     0,
       0,     0,    21,    22,     0,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,     0,  -149,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    46,     0,     0,     0,    48,
      49,    50,     0,     0,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,     0,     0,     0,    65,
      66,     0,    67,    68,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    69,     0,     0,    70,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    71,    72,     0,
       0,     0,    73,     0,     0,     0,     0,    74,     0,    75,
      76,    77,     0,     0,     0,    78,     0,    79,    10,   133,
     134,    80,     0,     0,    14,     0,     0,    16,     0,     0,
       0,     0,     0,     0,    21,    22,     0,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    46,     0,     0,
       0,    48,    49,    50,     0,     0,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,     0,     0,
       0,    65,    66,     0,    67,    68,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    69,     0,     0,    70,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    71,
     289,     0,     0,     0,    73,     0,     0,     0,     0,    74,
       0,    75,    76,    77,     0,     0,     0,    78,   165,    79,
      10,   133,   134,    80,     0,     0,    14,   422,     0,    16,
       0,     0,     0,     0,     0,     0,    21,    22,     0,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    46,
       0,     0,     0,    48,    49,    50,     0,     0,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
       0,     0,     0,    65,    66,     0,    67,    68,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    69,     0,
       0,    70,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    71,    72,     0,     0,     0,    73,     0,     0,     0,
       0,    74,     0,    75,    76,    77,     0,     0,     0,    78,
       0,    79,    10,   133,   134,    80,     0,     0,    14,   422,
       0,    16,     0,     0,     0,     0,     0,     0,    21,    22,
       0,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    46,     0,     0,     0,    48,    49,    50,     0,     0,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,     0,     0,     0,    65,    66,     0,    67,    68,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      69,     0,     0,    70,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    71,    72,     0,     0,     0,    73,     0,
       0,     0,     0,    74,     0,    75,    76,    77,     0,     0,
       0,   494,     0,    79,    10,   133,   134,    80,     0,     0,
      14,     0,     0,    16,     0,     0,     0,     0,     0,     0,
      21,    22,     0,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    46,     0,     0,     0,    48,    49,    50,
       0,     0,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,     0,     0,     0,    65,    66,     0,
      67,    68,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    69,     0,     0,    70,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    71,    72,     0,     0,     0,
      73,     0,     0,     0,     0,    74,     0,    75,    76,    77,
      10,   133,   134,    78,     0,    79,     0,     0,  -172,    80,
       0,     0,     0,     0,     0,     0,    21,    22,     0,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      10,   133,   134,     0,     0,     0,     0,     0,  -174,     0,
       0,     0,     0,     0,    49,   198,    21,    22,     0,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    49,   198,     0,     0,   199,     0,
       0,   200,     0,     0,    10,   133,   134,     0,     0,     0,
       0,     0,   201,     0,     0,     0,   202,     0,     0,     0,
      21,    22,     0,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     0,   203,     0,     0,   199,     0,
       0,   200,     0,     0,    10,   133,   134,     0,     0,     0,
       0,     0,   201,     0,     0,     0,   202,   444,   445,   198,
      21,    22,     0,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     0,   203,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   217,
       0,     0,     0,   437,     0,     0,     0,     0,    49,   198,
       0,     0,   199,     0,     0,   200,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   201,     0,     0,     0,
     202,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   203,
       0,     0,   199,     0,     0,   200,   217,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   201,     0,     0,     0,
     202,     0,   459,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   203,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,     0,   252,
     253,   254,     0,   217,   255,     0,     0,   256,   257,     0,
       0,     0,   258,     0,   259,   260,   261,     0,   262,   280,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,     0,   252,   253,   254,     0,
     217,   255,     0,     0,   256,   257,     0,     0,     0,   258,
       0,   259,   260,   261,     0,   262,   398,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,   252,   253,   254,     0,   217,   255,     0,
       0,   256,   257,     0,     0,     0,   258,     0,   259,   260,
     261,     0,   262,   399,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,     0,
     252,   253,   254,   217,     0,   255,     0,     0,   256,   257,
       0,     0,     0,   258,     0,   259,   260,   261,     0,   262,
     404,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,     0,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,     0,   252,   253,   254,
       0,     0,   255,     0,   217,   256,   257,     0,     0,     0,
     258,     0,   259,   260,   261,     0,   262,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   455,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,   252,   253,   254,     0,     0,   255,     0,
     217,   256,   257,     0,     0,     0,   258,     0,   259,   260,
     261,     0,   262,   551,     0,     0,     0,     0,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   217,   252,   253,   254,     0,     0,   255,
       0,     0,   256,   257,     0,     0,     0,   258,     0,   259,
     260,   261,     0,   262,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
       0,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   217,
     252,   253,   254,     0,     0,   255,     0,     0,   256,   257,
       0,     0,     0,   258,     0,   259,   260,   261,     0,   262,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   233,     0,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   217,   252,   253,   254,     0,     0,   255,     0,
       0,   256,   257,     0,     0,     0,   258,     0,   259,   260,
     261,     0,   262,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   217,     0,
       0,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,     0,   252,
     253,   254,     0,     0,   255,     0,     0,   256,   257,     0,
       0,     0,   258,   217,   259,   260,   261,     0,   262,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   217,   252,   253,   254,     0,     0,   255,     0,     0,
     256,   257,     0,     0,     0,   258,     0,   259,   260,   261,
       0,   262,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,     0,   252,   253,
     254,     0,     0,   255,     0,     0,   256,   257,     0,     0,
       0,   258,     0,   259,   260,   261,     0,   262,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,     0,   252,   253,   254,     0,     0,   255,     0,
       0,   256,   257,     0,     0,     0,   258,     0,   259,   260,
     261,     0,   262,     0,     0,     0,     0,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
       0,   252,   253,   254,     0,     0,   255,     0,     0,   256,
     257,     0,     0,     0,   258,     0,   259,   260,   261,     0,
     262
};

static const yytype_int16 yycheck[] =
{
       7,   101,    80,   377,    45,   441,    45,     7,    85,    45,
     552,    90,   112,   113,   196,    89,    35,    11,    11,    59,
     264,    11,   266,   179,   319,   176,   105,    17,   193,    46,
       7,    11,   448,    16,    51,    13,    85,    85,    45,    80,
      16,    59,    60,    59,    80,   419,   616,    13,   116,   126,
     206,   103,    69,    70,    71,    72,    73,    74,    75,    76,
      77,   531,    69,    70,   143,    72,    73,   146,    45,   116,
      59,   135,    13,    80,   142,    13,    38,   141,    40,    41,
     650,    88,    56,    57,   136,    11,    95,   136,   136,    36,
      11,    37,    85,   258,   101,   142,   261,   137,   116,   515,
     116,    37,    85,    80,    84,   112,   113,   144,    86,    85,
     210,   406,    59,    56,    57,   116,   586,   116,   127,   128,
     129,   130,    59,    60,    61,   667,   141,   116,    59,    60,
      61,   116,   141,   150,   151,   136,   137,    34,   137,   383,
      60,    61,    39,    40,    41,    42,    59,    60,   299,   166,
      47,   136,   137,    59,   141,    61,   150,   536,   537,   166,
     150,   170,    51,   136,   171,    18,    19,    20,    21,   176,
     116,    37,   608,   214,    44,    59,   193,    61,   214,   553,
     116,    59,   189,    61,    81,    82,   193,   194,   197,   345,
     626,   137,   199,   200,   201,   202,   203,    85,   493,   216,
     217,   137,    59,   210,   150,    59,   142,   214,   499,   141,
     501,    59,    12,    11,   150,   315,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   314,   214,   312,   404,
      85,   258,   142,   178,   261,   262,   263,   142,   430,   431,
     545,   433,   434,   144,   271,    11,   551,    18,    19,    20,
      21,    78,    11,   280,   150,    59,   273,   141,   347,   346,
      86,    59,   289,   273,   116,   150,    59,    38,    59,    40,
      41,    14,   289,    44,   181,    14,    85,   296,   122,   123,
     124,    14,   299,   127,   141,   141,   130,   131,   593,   308,
     141,   135,   319,   137,   138,   139,   141,   141,   315,   141,
     207,   208,   209,   144,    12,   212,   116,   117,   118,   119,
     120,    11,   122,   123,   124,   344,   136,   127,    59,    13,
     130,   131,   141,    14,    13,   135,   343,   137,   138,   139,
     142,   141,    85,   136,   141,    85,   387,   136,   389,   390,
     391,   387,   391,   389,   390,   391,    64,    65,    66,    67,
      68,   461,   462,   142,   127,   141,   407,   130,   131,   136,
      59,   407,   135,   142,   137,   138,   139,   136,   141,   314,
     387,    11,   389,   390,   391,    11,    48,   404,   142,   489,
     150,   398,   150,    59,   142,   142,   118,   142,   142,    13,
     407,    14,   141,   149,    86,   422,    59,   481,    16,    11,
     387,    85,   389,   390,   391,    85,    11,   568,   150,    11,
     118,   119,   120,   142,   122,   123,   124,   141,    11,   127,
     407,   438,   130,   131,   443,   142,   142,   135,   455,   137,
     138,   139,   459,   141,    11,   486,   142,   142,    86,    59,
     486,    85,    85,    85,   461,   462,   142,    13,   141,    11,
      13,    59,    13,   480,    13,   484,   475,    13,   477,   478,
     487,   142,    16,    14,    86,    14,   493,    86,   142,   486,
     148,   142,   489,   561,    85,   494,   560,   528,   562,   530,
     641,   532,   528,   532,   530,   569,   532,   571,    14,   518,
     574,    14,   102,   577,    35,   136,   580,   658,   582,   486,
      11,   102,   663,   102,    59,    14,    59,   102,   282,   281,
     527,   528,   529,   530,   171,   532,   518,   527,   545,   529,
     681,   617,   541,   540,   551,   552,   651,   554,   612,   530,
     540,   193,   429,   461,   513,   462,   438,   585,   459,   489,
     440,   528,   280,   530,   628,   532,   271,    16,   630,   576,
     535,   568,   579,    -1,   581,   551,   554,    -1,    -1,   647,
     101,   645,   556,   614,    -1,   653,   593,   512,   614,   514,
      -1,   112,   113,    -1,   519,    -1,    -1,   661,   605,    -1,
      -1,    -1,    -1,    -1,    -1,   669,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   614,   682,    -1,
      -1,    -1,   619,    -1,    -1,    -1,    -1,    -1,   625,   619,
      -1,    -1,    -1,    -1,    -1,   625,    -1,    -1,    -1,    -1,
     565,    -1,    -1,    -1,   641,    -1,    -1,   614,    -1,   648,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     667,   658,    -1,    -1,    -1,    -1,   663,    -1,   189,    -1,
      -1,    -1,    -1,   194,    -1,    -1,    -1,    -1,   199,   200,
     201,   202,   203,    -1,   681,    -1,   611,    -1,   613,   210,
      -1,    -1,    -1,   618,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   636,    -1,   638,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   652,    -1,    -1,
     655,    -1,    -1,    -1,    -1,   660,    -1,     0,     1,    -1,
      -1,    -1,    -1,     6,     7,     8,    -1,    -1,    11,    12,
      13,    -1,    15,    -1,    17,    18,    19,    20,    21,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    -1,
      -1,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,   315,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    79,    80,    -1,    82,
      83,    -1,   343,   344,    -1,    -1,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   117,   118,    -1,    -1,    -1,   122,
      -1,    -1,    -1,    -1,   127,    -1,   129,   130,   131,    -1,
      -1,    -1,   135,    -1,   137,    -1,    -1,   398,   141,    -1,
      -1,    -1,   145,   146,    -1,    -1,    -1,   150,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   438,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
     461,   462,   127,    -1,    -1,   130,   131,    -1,    -1,    -1,
     135,    -1,   137,   138,   139,    -1,   141,    -1,    -1,    -1,
      -1,    -1,    -1,   484,    -1,     6,     7,     8,   489,    -1,
      11,    12,    13,    14,    15,    -1,    -1,    18,    19,    20,
      21,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,   518,    39,    -1,
      -1,    -1,    -1,    -1,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    79,    80,
      -1,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   117,   118,    -1,    -1,
      -1,   122,    12,    -1,    -1,    -1,   127,    -1,   129,   130,
     131,    -1,    -1,    -1,   135,    -1,   137,    -1,    -1,    -1,
     141,     6,     7,     8,   145,   146,    11,    12,    13,    -1,
      15,    -1,    -1,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    -1,    39,    -1,    -1,    -1,    -1,    -1,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    79,    80,    -1,    82,    83,    -1,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    -1,   122,   123,   124,    -1,    -1,   127,    -1,   104,
     130,   131,   107,    -1,    -1,   135,    -1,   137,   138,   139,
      -1,   141,   117,   118,    12,    -1,    -1,   122,    -1,    -1,
      -1,    -1,   127,    -1,   129,   130,   131,    -1,    -1,    -1,
     135,    -1,   137,    -1,    -1,    -1,   141,     6,     7,     8,
     145,   146,    11,    12,    13,    14,    15,    -1,    -1,    18,
      19,    20,    21,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    -1,
      39,    -1,    -1,    -1,    -1,    -1,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    58,
      59,    60,    61,    -1,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,    -1,
      79,    80,    -1,    82,    83,    -1,   114,   115,   116,   117,
     118,   119,   120,    -1,   122,   123,   124,    -1,    -1,   127,
      -1,    -1,   130,   131,    -1,   104,    -1,   135,   107,   137,
     138,   139,    -1,   141,    -1,    -1,    -1,    -1,   117,   118,
      -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,   127,    -1,
     129,   130,   131,    -1,    -1,    -1,   135,    -1,   137,    -1,
      -1,    -1,   141,     6,     7,     8,   145,   146,    11,    12,
      13,    -1,    15,    -1,    -1,    18,    19,    20,    21,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    58,    59,    60,    61,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    79,    80,    -1,    82,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   117,   118,    -1,    -1,    -1,   122,
      -1,    -1,    -1,    -1,   127,    -1,   129,   130,   131,    -1,
      -1,    -1,   135,    -1,   137,    -1,    -1,    -1,   141,     6,
       7,     8,   145,   146,    11,    12,    13,    -1,    15,    -1,
      -1,    18,    19,    20,    21,    22,    23,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    -1,    39,    -1,    -1,    -1,    -1,    -1,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    58,    59,    60,    61,    -1,    -1,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    -1,
      -1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,
     107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     117,   118,    -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,
     127,    -1,   129,   130,   131,    -1,    -1,    -1,   135,    -1,
     137,     6,     7,     8,   141,    -1,    -1,    12,   145,   146,
      15,    -1,    -1,    18,    19,    20,    21,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      55,    -1,    -1,    -1,    59,    60,    61,    -1,    -1,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    -1,    -1,    -1,    79,    80,    -1,    82,    83,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   117,   118,    -1,    -1,    -1,   122,    -1,    -1,
      -1,    -1,   127,    -1,   129,   130,   131,    -1,    -1,    -1,
     135,    -1,   137,     6,     7,     8,   141,   142,    -1,    12,
      -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    -1,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,    -1,
      -1,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    -1,    -1,    -1,    79,    80,    -1,    82,
      83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   117,   118,    -1,    -1,    -1,   122,
      -1,    -1,    -1,    -1,   127,    -1,   129,   130,   131,    -1,
      -1,    -1,   135,    -1,   137,     6,     7,     8,   141,   142,
      -1,    12,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,
      61,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    -1,    -1,    -1,    79,    80,
      -1,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   117,   118,    -1,    -1,
      -1,   122,    -1,    -1,    -1,    -1,   127,    -1,   129,   130,
     131,     6,     7,     8,   135,    -1,   137,    -1,    -1,    -1,
     141,   142,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     6,     7,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    22,    23,    -1,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,   104,
      -1,    -1,   107,    -1,    -1,    -1,     6,     7,     8,    -1,
      -1,    11,    12,   118,    -1,    15,    -1,   122,    18,    19,
      20,    21,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,   141,   142,    -1,   104,
      -1,    -1,   107,    -1,    -1,    45,    46,    -1,    -1,    -1,
      -1,    -1,    -1,   118,    -1,    55,    -1,   122,    -1,    59,
      60,    61,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,   141,   142,    -1,    79,
      80,    -1,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,   118,    -1,
      -1,    -1,   122,    -1,    -1,    -1,    -1,   127,    -1,   129,
     130,   131,    -1,    -1,    -1,   135,    -1,   137,     6,     7,
       8,   141,    -1,    -1,    12,    13,    -1,    15,    -1,    -1,
      18,    19,    20,    21,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,    46,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    59,    60,    61,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    80,    -1,    82,    83,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
     118,    -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,   127,
      -1,   129,   130,   131,    -1,    -1,    -1,   135,    -1,   137,
       6,     7,     8,   141,    -1,    -1,    12,    -1,    -1,    15,
      -1,    -1,    18,    19,    20,    21,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    45,
      46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    59,    60,    61,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,   118,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,   127,    -1,   129,   130,   131,    -1,    -1,    -1,   135,
      -1,   137,     6,     7,     8,   141,    -1,    -1,    12,    -1,
      -1,    15,    -1,    -1,    18,    19,    20,    21,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    59,    60,    61,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    79,    80,    -1,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,   118,    -1,    -1,    -1,   122,    -1,
      -1,    -1,    -1,   127,    -1,   129,   130,   131,    -1,    -1,
      -1,   135,    -1,   137,     6,     7,     8,   141,    -1,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    80,    81,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,   118,    -1,    -1,    -1,
     122,    -1,    -1,    -1,    -1,   127,    -1,   129,   130,   131,
      -1,    -1,    -1,   135,    -1,   137,     6,     7,     8,   141,
      -1,    -1,    12,    -1,    -1,    15,    16,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,
      60,    61,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      80,    -1,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,   118,    -1,
      -1,    -1,   122,    -1,    -1,    -1,    -1,   127,    -1,   129,
     130,   131,    -1,    -1,    -1,   135,   136,   137,     6,     7,
       8,   141,    -1,    -1,    12,    13,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    37,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    59,    60,    61,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    80,    -1,    82,    83,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
     118,    -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,   127,
      -1,   129,   130,   131,    -1,    -1,    -1,   135,    -1,   137,
       6,     7,     8,   141,    -1,    -1,    12,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    59,    60,    61,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    80,    81,    82,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,   118,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,   127,    -1,   129,   130,   131,    -1,    -1,    -1,   135,
      -1,   137,     6,     7,     8,   141,    -1,    -1,    12,    -1,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    59,    60,    61,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    79,    80,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,   118,    -1,    -1,    -1,   122,    -1,
      -1,    -1,    -1,   127,    -1,   129,   130,   131,    -1,    -1,
      -1,   135,    -1,   137,     6,     7,     8,   141,    -1,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    80,    -1,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,   118,    -1,    -1,    -1,
     122,    -1,    -1,    -1,    -1,   127,    -1,   129,   130,   131,
      -1,    -1,    -1,   135,    -1,   137,     6,     7,     8,   141,
      -1,    -1,    12,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,
      60,    61,    -1,    -1,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    -1,    -1,    -1,    79,
      80,    -1,    82,    83,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   104,    -1,    -1,   107,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,   118,    -1,
      -1,    -1,   122,    -1,    -1,    -1,    -1,   127,    -1,   129,
     130,   131,    -1,    -1,    -1,   135,    -1,   137,     6,     7,
       8,   141,    -1,    -1,    12,    -1,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    59,    60,    61,    -1,    -1,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    -1,    -1,
      -1,    79,    80,    -1,    82,    83,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,    -1,   107,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   117,
     118,    -1,    -1,    -1,   122,    -1,    -1,    -1,    -1,   127,
      -1,   129,   130,   131,    -1,    -1,    -1,   135,   136,   137,
       6,     7,     8,   141,    -1,    -1,    12,    13,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    59,    60,    61,    -1,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      -1,    -1,    -1,    79,    80,    -1,    82,    83,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,   118,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      -1,   127,    -1,   129,   130,   131,    -1,    -1,    -1,   135,
      -1,   137,     6,     7,     8,   141,    -1,    -1,    12,    13,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      -1,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    59,    60,    61,    -1,    -1,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    -1,    -1,    -1,    79,    80,    -1,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     104,    -1,    -1,   107,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   117,   118,    -1,    -1,    -1,   122,    -1,
      -1,    -1,    -1,   127,    -1,   129,   130,   131,    -1,    -1,
      -1,   135,    -1,   137,     6,     7,     8,   141,    -1,    -1,
      12,    -1,    -1,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,
      -1,    -1,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    -1,    -1,    -1,    79,    80,    -1,
      82,    83,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   117,   118,    -1,    -1,    -1,
     122,    -1,    -1,    -1,    -1,   127,    -1,   129,   130,   131,
       6,     7,     8,   135,    -1,   137,    -1,    -1,    14,   141,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       6,     7,     8,    -1,    -1,    -1,    -1,    -1,    14,    -1,
      -1,    -1,    -1,    -1,    60,    61,    22,    23,    -1,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,     6,     7,     8,    -1,    -1,    -1,
      -1,    -1,   118,    -1,    -1,    -1,   122,    -1,    -1,    -1,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,   141,    -1,    -1,   104,    -1,
      -1,   107,    -1,    -1,     6,     7,     8,    -1,    -1,    -1,
      -1,    -1,   118,    -1,    -1,    -1,   122,    59,    60,    61,
      22,    23,    -1,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,   141,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,
      -1,    -1,    -1,    16,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,   104,    -1,    -1,   107,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,
     122,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   141,
      -1,    -1,   104,    -1,    -1,   107,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,
     122,    -1,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   141,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,    -1,    12,   127,    -1,    -1,   130,   131,    -1,
      -1,    -1,   135,    -1,   137,   138,   139,    -1,   141,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,    -1,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,    -1,   122,   123,   124,    -1,
      12,   127,    -1,    -1,   130,   131,    -1,    -1,    -1,   135,
      -1,   137,   138,   139,    -1,   141,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,    -1,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,    -1,    12,   127,    -1,
      -1,   130,   131,    -1,    -1,    -1,   135,    -1,   137,   138,
     139,    -1,   141,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    -1,
     122,   123,   124,    12,    -1,   127,    -1,    -1,   130,   131,
      -1,    -1,    -1,   135,    -1,   137,   138,   139,    -1,   141,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,    -1,   122,   123,   124,
      -1,    -1,   127,    -1,    12,   130,   131,    -1,    -1,    -1,
     135,    -1,   137,   138,   139,    -1,   141,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,    -1,    -1,   127,    -1,
      12,   130,   131,    -1,    -1,    -1,   135,    -1,   137,   138,
     139,    -1,   141,    81,    -1,    -1,    -1,    -1,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,    -1,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,    12,   122,   123,   124,    -1,    -1,   127,
      -1,    -1,   130,   131,    -1,    -1,    -1,   135,    -1,   137,
     138,   139,    -1,   141,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,    12,
     122,   123,   124,    -1,    -1,   127,    -1,    -1,   130,   131,
      -1,    -1,    -1,   135,    -1,   137,   138,   139,    -1,   141,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   101,    -1,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    12,   122,   123,   124,    -1,    -1,   127,    -1,
      -1,   130,   131,    -1,    -1,    -1,   135,    -1,   137,   138,
     139,    -1,   141,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    12,    -1,
      -1,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,    -1,   122,
     123,   124,    -1,    -1,   127,    -1,    -1,   130,   131,    -1,
      -1,    -1,   135,    12,   137,   138,   139,    -1,   141,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,    12,   122,   123,   124,    -1,    -1,   127,    -1,    -1,
     130,   131,    -1,    -1,    -1,   135,    -1,   137,   138,   139,
      -1,   141,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,    -1,   122,   123,
     124,    -1,    -1,   127,    -1,    -1,   130,   131,    -1,    -1,
      -1,   135,    -1,   137,   138,   139,    -1,   141,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,    -1,   122,   123,   124,    -1,    -1,   127,    -1,
      -1,   130,   131,    -1,    -1,    -1,   135,    -1,   137,   138,
     139,    -1,   141,    -1,    -1,    -1,    -1,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
      -1,   122,   123,   124,    -1,    -1,   127,    -1,    -1,   130,
     131,    -1,    -1,    -1,   135,    -1,   137,   138,   139,    -1,
     141
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   152,     0,     1,    17,   150,   153,   158,   162,   157,
       6,     7,     8,    11,    12,    13,    15,    18,    19,    20,
      21,    22,    23,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    39,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    79,    80,    82,    83,   104,
     107,   117,   118,   122,   127,   129,   130,   131,   135,   137,
     141,   145,   146,   168,   169,   171,   172,   175,   176,   179,
     180,   181,   185,   192,   209,   210,   212,   214,   215,   216,
     217,   225,   226,   227,   228,   238,   239,   246,    11,    17,
     150,   154,    13,    13,    13,    64,    65,    66,    67,    68,
     249,   173,   247,   249,   155,   169,   171,   155,   155,   155,
     155,    11,    11,     7,     8,   212,   227,   237,   238,   214,
     246,   155,   144,   240,   241,   246,   163,   164,   165,   167,
     141,   141,   214,   246,   214,   246,   246,   214,   246,   214,
     246,   246,   246,   246,   246,   136,   135,   175,   214,   238,
     155,   155,    60,    61,   172,   178,   180,   238,   174,   157,
     156,    51,   193,   194,   173,    36,    59,   206,   207,   116,
     137,   150,   159,   135,   141,   213,   229,    37,    61,   104,
     107,   118,   122,   141,   171,   214,   216,    38,    40,    41,
     224,   225,    44,    11,    84,   157,    85,    12,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   122,   123,   124,   127,   130,   131,   135,   137,
     138,   139,   141,   248,   216,   222,   216,   223,    59,   203,
      59,   141,   173,   173,   173,   173,    59,    11,   173,   157,
      85,   157,    85,    59,    60,    61,   166,   246,   246,   118,
     214,   219,   221,   246,   142,   137,   142,   142,   173,    13,
     181,   184,   144,   174,   177,   178,   156,   159,   155,    78,
     195,    11,   188,   189,   190,   155,   233,    59,   141,    86,
     211,   214,    59,    16,   214,   218,   219,   220,   221,   142,
     214,   230,   231,   213,   173,   214,   214,   214,   214,   214,
      61,   159,   155,   155,   155,   216,   155,   238,   150,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   221,    59,    59,   221,   242,   243,   246,   246,   203,
      14,   203,    14,    85,    14,   141,   240,   141,   180,   141,
     141,   141,    11,   160,   241,   160,   164,   144,    85,    85,
     136,    85,   136,   136,    85,    59,   173,   141,   178,   186,
      14,   173,   174,   156,   175,   191,   214,   216,   234,   235,
     142,   141,    13,   246,   251,   259,   263,   266,    85,   208,
     136,   136,    85,   136,   136,    59,   142,    16,    85,   236,
     141,   232,   142,    59,    59,    60,   204,   205,   214,   169,
     170,   159,    61,   172,   157,   102,   136,   136,   142,    85,
     236,    11,    11,   203,   142,   238,    48,   183,   237,   238,
     237,   150,   150,   214,    59,   142,   118,   142,   142,   221,
     142,   266,   238,    14,   149,   187,   141,    86,    59,    85,
     236,    14,    59,    81,   135,   137,   246,   256,   257,   260,
     261,   264,   265,   266,   206,   213,   213,    16,   213,   213,
     230,   233,   194,   173,    11,    85,    60,   204,    85,    11,
     182,   150,   246,   243,   222,   223,    11,   142,   141,   142,
      11,   142,    11,   142,   142,   173,   173,   173,   246,   174,
     142,   169,   238,   246,   234,    86,   246,   262,   266,   173,
      59,    81,    85,   161,    85,   161,    85,   161,   142,   156,
     244,   245,   229,   156,   204,    11,   170,   156,    13,   180,
     238,   180,   183,   176,   196,   237,    13,   258,   259,    13,
     251,    13,   250,   251,   180,   173,   142,    11,   246,   266,
      59,   253,   254,    86,   262,   246,   257,   236,   246,   261,
      14,    59,   137,   265,    14,    86,   174,   175,   174,   156,
     178,   174,   142,   174,    56,    57,   197,   198,   174,   142,
      14,   174,   174,    14,   174,   148,   232,   176,   199,   255,
      85,   246,   266,    14,   246,   194,    14,   156,   174,   156,
     238,   102,   177,   197,   156,   180,   180,   194,    56,    57,
     200,   201,   174,   136,   253,    11,   156,   156,   102,   178,
     174,   175,   173,   102,   177,   200,   156,    86,   175,   252,
     156,   178,   156,   174,    59,   178,   257,   174,    59,   202,
      14,   102,   178,   174
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   151,   152,   152,   153,   153,   154,   154,   154,   155,
     156,   157,   158,   159,   159,   160,   160,   161,   161,   162,
     162,   162,   162,   162,   162,   162,   163,   163,   164,   164,
     165,   166,   166,   166,   167,   167,   168,   168,   169,   169,
     170,   170,   171,   171,   172,   172,   173,   174,   175,   176,
     177,   178,   178,   179,   179,   180,   180,   181,   181,   181,
     181,   181,   181,   181,   181,   181,   181,   181,   181,   181,
     181,   181,   181,   182,   181,   181,   181,   181,   183,   183,
     184,   184,   185,   186,   186,   187,   188,   188,   190,   189,
     191,   191,   192,   192,   193,   194,   195,   195,   196,   197,
     197,   198,   198,   199,   200,   200,   201,   201,   202,   202,
     203,   203,   204,   204,   205,   205,   206,   206,   207,   208,
     209,   210,   210,   210,   211,   211,   211,   212,   212,   212,
     213,   213,   213,   213,   213,   213,   214,   214,   214,   214,
     214,   214,   215,   215,   215,   215,   215,   215,   216,   216,
     217,   217,   217,   217,   217,   217,   217,   217,   217,   217,
     217,   217,   217,   218,   218,   219,   219,   220,   220,   221,
     221,   222,   222,   223,   223,   224,   224,   225,   225,   225,
     225,   226,   226,   227,   227,   228,   228,   229,   229,   230,
     230,   231,   231,   232,   233,   233,   234,   234,   235,   235,
     236,   236,   237,   237,   238,   238,   239,   239,   240,   240,
     241,   241,   242,   242,   243,   243,   244,   245,   244,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
     246,   247,   247,   248,   248,   248,   248,   248,   248,   248,
     248,   248,   248,   248,   248,   248,   248,   248,   249,   249,
     249,   249,   249,   250,   250,   250,   251,   251,   252,   252,
     253,   253,   254,   255,   256,   256,   257,   257,   258,   258,
     258,   259,   260,   260,   261,   261,   262,   262,   263,   264,
     264,   265,   265,   265,   265,   266,   266,   266,   266
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     0,     1,     3,     1,     1,     1,     0,
       0,     0,     0,     1,     0,     1,     0,     1,     0,     4,
       6,     4,     6,     6,     1,     1,     1,     0,     3,     1,
       2,     1,     1,     1,     3,     0,     2,     1,     2,     1,
       1,     3,     3,     2,     1,     1,     0,     0,     3,     2,
       2,     2,     0,     7,     9,     1,     1,     3,     9,    10,
       9,     9,    10,     2,     2,     3,     2,     1,     4,    10,
       6,     6,     7,     0,     9,     6,     2,    11,     3,     1,
       1,     3,     4,     2,     0,     7,     1,     1,     0,     2,
       1,     4,     1,     1,     0,     2,     1,     0,     3,     2,
       0,     4,     3,     3,     2,     0,     7,     3,     1,     0,
       3,     1,     3,     1,     1,     1,     4,     2,     1,     1,
       4,     3,     4,     4,     2,     2,     0,     4,     3,     2,
       2,     4,     4,     4,     4,     0,     2,     2,     2,     2,
       2,     3,     1,     4,     4,     4,     3,     1,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     3,     1,     3,     1,     3,
       1,     4,     0,     4,     0,     1,     0,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     3,     2,     3,
       2,     2,     1,     3,     2,     1,     3,     2,     2,     1,
       1,     0,     1,     0,     1,     2,     1,     3,     1,     0,
       3,     1,     1,     0,     3,     2,     3,     0,     2,     3,
       7,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     3,     3,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     6,     8,     8,     8,     3,     6,
       2,     1,     3,     3,     4,     4,     4,     6,     6,     3,
       3,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     0,     5,     9,     2,     1,
       3,     1,     1,     0,     3,     1,     1,     1,     1,     2,
       0,     4,     3,     1,     3,     2,     1,     1,     4,     3,
       1,     3,     3,     4,     4,     1,     1,     1,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 6: /* eend: NL  */
#line 197 "gram.y"
                    { yyerrok; }
#line 3149 "gram.c"
    break;

  case 7: /* eend: SEMI  */
#line 199 "gram.y"
                    { yyerrok; }
#line 3155 "gram.c"
    break;

  case 8: /* eend: ENDFILE  */
#line 201 "gram.y"
                    { yyerrok; }
#line 3161 "gram.c"
    break;

  case 9: /* ignorenl: %empty  */
#line 209 "gram.y"
                    { ignorenl++; }
#line 3167 "gram.c"
    break;

  case 10: /* attendnl: %empty  */
#line 212 "gram.y"
                    { if (ignorenl > 0) ignorenl--; }
#line 3173 "gram.c"
    break;

  case 11: /* reset: %empty  */
#line 215 "gram.y"
                    { 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
			lastThreadError = True;
		    }
#line 3186 "gram.c"
    break;

  case 12: /* not_command: %empty  */
#line 233 "gram.y"
                    { notCommand = 1; }
#line 3192 "gram.c"
    break;

  case 19: /* command: not_command expr reset NL  */
#line 248 "gram.y"
                    {
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, (yyvsp[-2].expr), 0));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
#line 3212 "gram.c"
    break;

  case 20: /* command: not_command expr POUND expr reset NL  */
#line 264 "gram.y"
                    {
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, (yyvsp[-4].expr), 0), (yyvsp[-2].expr));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
#line 3232 "gram.c"
    break;

  case 21: /* command: not_command statement reset opt_nl  */
#line 280 "gram.y"
                    { 
			ENTER ();
			NamespacePtr    s;
			FramePtr	f;
			CodePtr		c;
			Value		t;
			
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileStat ((yyvsp[-2].expr), c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
#line 3249 "gram.c"
    break;

  case 22: /* command: not_command COMMAND opt_exprs reset opt_semi NL  */
#line 293 "gram.y"
                    {
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, (yyvsp[-4].atom));
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName ((yyvsp[-4].atom)));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     (yyvsp[-3].expr));
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
#line 3277 "gram.c"
    break;

  case 23: /* command: not_command NAMECOMMAND opt_rawnames reset opt_semi NL  */
#line 317 "gram.y"
                    {
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, (yyvsp[-4].atom));
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName ((yyvsp[-4].atom)));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     (yyvsp[-3].expr));
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
#line 3306 "gram.c"
    break;

  case 27: /* opt_rawnames: %empty  */
#line 346 "gram.y"
                    { (yyval.expr) = 0; }
#line 3312 "gram.c"
    break;

  case 28: /* rawnames: rawname COMMA rawnames  */
#line 349 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 3318 "gram.c"
    break;

  case 29: /* rawnames: rawname  */
#line 351 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[0].expr), 0); }
#line 3324 "gram.c"
    break;

  case 30: /* rawname: rawnamespace rawatom  */
#line 354 "gram.y"
                    { (yyval.expr) = BuildRawname ((yyvsp[-1].expr), (yyvsp[0].atom)); }
#line 3330 "gram.c"
    break;

  case 34: /* rawnamespace: rawnamespace rawatom COLONCOLON  */
#line 361 "gram.y"
                    { (yyval.expr) = NewExprTree (COLONCOLON, (yyvsp[-2].expr), NewExprAtom ((yyvsp[-1].atom), 0, False)); }
#line 3336 "gram.c"
    break;

  case 35: /* rawnamespace: %empty  */
#line 363 "gram.y"
                    { (yyval.expr) = 0; }
#line 3342 "gram.c"
    break;

  case 36: /* fulltype: namespace TYPENAME  */
#line 366 "gram.y"
                    { 
			(yyval.expr) = BuildFullname ((yyvsp[-1].expr), (yyvsp[0].atom));
			LexNamespace = 0;
		    }
#line 3351 "gram.c"
    break;

  case 37: /* fulltype: TYPENAME  */
#line 371 "gram.y"
                    { 
			(yyval.expr) = BuildFullname (0, (yyvsp[0].atom));
			LexNamespace = 0;
		    }
#line 3360 "gram.c"
    break;

  case 38: /* fullname: namespace namespacename  */
#line 377 "gram.y"
                    { 
			(yyval.expr) = BuildFullname ((yyvsp[-1].expr), (yyvsp[0].atom));
			LexNamespace = 0;
		    }
#line 3369 "gram.c"
    break;

  case 39: /* fullname: namespacename  */
#line 382 "gram.y"
                    {
			(yyval.expr) = BuildFullname (0, (yyvsp[0].atom));
			LexNamespace = 0;
		    }
#line 3378 "gram.c"
    break;

  case 40: /* fullnames: fullname  */
#line 388 "gram.y"
                    {
			(yyval.expr) = (yyvsp[0].expr);
		    }
#line 3386 "gram.c"
    break;

  case 41: /* fullnames: fullname COMMA fullnames  */
#line 392 "gram.y"
                    {
			(yyval.expr) = NewExprTree (COMMA, (yyvsp[-2].expr), (yyvsp[0].expr));
		    }
#line 3394 "gram.c"
    break;

  case 42: /* namespace: namespace NAMESPACENAME COLONCOLON  */
#line 397 "gram.y"
                    { 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname ((yyvsp[-2].expr), (yyvsp[-1].atom));
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", (yyvsp[-1].atom));
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", (yyvsp[-1].atom));
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			(yyval.expr) = e;
		    }
#line 3421 "gram.c"
    break;

  case 43: /* namespace: NAMESPACENAME COLONCOLON  */
#line 420 "gram.y"
                    { 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, (yyvsp[-1].atom));
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", (yyvsp[-1].atom));
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", (yyvsp[-1].atom));
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			(yyval.expr) = e;
		    }
#line 3448 "gram.c"
    break;

  case 46: /* namespace_start: %empty  */
#line 450 "gram.y"
                    { CurrentNamespace = NewNamespace (CurrentNamespace); }
#line 3454 "gram.c"
    break;

  case 47: /* namespace_end: %empty  */
#line 453 "gram.y"
                    { CurrentNamespace = CurrentNamespace->previous; }
#line 3460 "gram.c"
    break;

  case 48: /* block: block_start statements block_end  */
#line 456 "gram.y"
                    { (yyval.expr) = (yyvsp[-1].expr); }
#line 3466 "gram.c"
    break;

  case 51: /* statements: statement statements  */
#line 463 "gram.y"
                    { (yyval.expr) = NewExprTree(OC, (yyvsp[-1].expr), (yyvsp[0].expr)); }
#line 3472 "gram.c"
    break;

  case 52: /* statements: %empty  */
#line 465 "gram.y"
                    { (yyval.expr) = NewExprTree(OC, 0, 0); }
#line 3478 "gram.c"
    break;

  case 53: /* if_statement: IF ignorenl namespace_start OP expr CP statement  */
#line 468 "gram.y"
                    { (yyval.expr) = NewExprTree(IF, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 3484 "gram.c"
    break;

  case 54: /* if_statement: IF ignorenl namespace_start OP expr CP statement ELSE statement  */
#line 470 "gram.y"
                    { (yyval.expr) = NewExprTree(ELSE, (yyvsp[-4].expr), NewExprTree(ELSE, (yyvsp[-2].expr), (yyvsp[0].expr))); }
#line 3490 "gram.c"
    break;

  case 57: /* simple_statement: if_statement namespace_end attendnl  */
#line 477 "gram.y"
                    { (yyval.expr) = (yyvsp[-2].expr); }
#line 3496 "gram.c"
    break;

  case 58: /* simple_statement: WHILE ignorenl namespace_start OP expr CP statement namespace_end attendnl  */
#line 479 "gram.y"
                    { (yyval.expr) = NewExprTree(WHILE, (yyvsp[-4].expr), (yyvsp[-2].expr)); }
#line 3502 "gram.c"
    break;

  case 59: /* simple_statement: DO ignorenl namespace_start statement WHILE OP expr CP namespace_end attendnl  */
#line 481 "gram.y"
                    { (yyval.expr) = NewExprTree(DO, (yyvsp[-6].expr), (yyvsp[-3].expr)); }
#line 3508 "gram.c"
    break;

  case 60: /* simple_statement: FOR ignorenl namespace_start OP for_exprs CP statement namespace_end attendnl  */
#line 483 "gram.y"
                    { Expr *expr = ParseCanonFor((yyvsp[-4].expr));
		      if (!expr)
                          YYERROR;
		      (yyval.expr) = NewExprTree(FOR, expr, (yyvsp[-2].expr)); }
#line 3517 "gram.c"
    break;

  case 61: /* simple_statement: SWITCH ignorenl namespace_start OP expr CP case_block namespace_end attendnl  */
#line 488 "gram.y"
                    { (yyval.expr) = NewExprTree (SWITCH, (yyvsp[-4].expr), (yyvsp[-2].expr)); }
#line 3523 "gram.c"
    break;

  case 62: /* simple_statement: union_or_enum SWITCH ignorenl namespace_start OP expr CP union_case_block namespace_end attendnl  */
#line 490 "gram.y"
                    { (yyval.expr) = NewExprTree (UNION, (yyvsp[-4].expr), (yyvsp[-2].expr)); }
#line 3529 "gram.c"
    break;

  case 63: /* simple_statement: BREAK SEMI  */
#line 492 "gram.y"
                    { (yyval.expr) = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
#line 3535 "gram.c"
    break;

  case 64: /* simple_statement: CONTINUE SEMI  */
#line 494 "gram.y"
                    { (yyval.expr) = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
#line 3541 "gram.c"
    break;

  case 65: /* simple_statement: RETURNTOK opt_expr SEMI  */
#line 496 "gram.y"
                    { (yyval.expr) = NewExprTree (RETURNTOK, (Expr *) 0, (yyvsp[-1].expr)); }
#line 3547 "gram.c"
    break;

  case 66: /* simple_statement: expr SEMI  */
#line 498 "gram.y"
                    { (yyval.expr) = NewExprTree(EXPR, (yyvsp[-1].expr), (Expr *) 0); }
#line 3553 "gram.c"
    break;

  case 67: /* simple_statement: SEMI  */
#line 500 "gram.y"
                    { (yyval.expr) = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
#line 3559 "gram.c"
    break;

  case 68: /* simple_statement: func_decl doc_string opt_func_body namespace_end  */
#line 502 "gram.y"
                    { 
			DeclList    *decl = (yyvsp[-3].funcDecl).decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = (yyvsp[-3].funcDecl).type.class;
			Publish	    publish = (yyvsp[-3].funcDecl).type.publish;
			TypePtr	    type = (yyvsp[-3].funcDecl).type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if ((yyvsp[-1].expr))
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       (yyvsp[-1].expr),
								       (yyvsp[-2].value)),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			(yyval.expr) = NewExprDecl (FUNC, decl, class, type, publish);
		    }
#line 3590 "gram.c"
    break;

  case 69: /* simple_statement: opt_publish EXCEPTION ignorenl NAME namespace_start opt_argdecls namespace_end doc_string SEMI attendnl  */
#line 529 "gram.y"
                    { 
			DeclListPtr decl;

			decl = NewDeclList ((yyvsp[-6].atom), 0, 0);
			decl->symbol = ParseNewSymbol ((yyvsp[-9].publish), 
						       class_exception, 
						       typePoly, (yyvsp[-6].atom));
			decl->symbol->exception.doc = (yyvsp[-2].value);
			(yyval.expr) = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, (yyvsp[-4].argType)),
					  (yyvsp[-9].publish));
		    }
#line 3609 "gram.c"
    break;

  case 70: /* simple_statement: RAISE fullname OP opt_exprs CP SEMI  */
#line 544 "gram.y"
                    { (yyval.expr) = NewExprTree (RAISE, (yyvsp[-4].expr), (yyvsp[-2].expr)); }
#line 3615 "gram.c"
    break;

  case 71: /* simple_statement: opt_publish TYPEDEF ignorenl typenames SEMI attendnl  */
#line 546 "gram.y"
                    { 
			DeclListPtr decl;

			for (decl = (yyvsp[-2].declList); decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol ((yyvsp[-5].publish), class_typedef,
							   0, decl->name);
			(yyval.expr) = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, (yyvsp[-2].declList), class_typedef, 0, (yyvsp[-5].publish)), 0);
		    }
#line 3628 "gram.c"
    break;

  case 72: /* simple_statement: opt_publish TYPEDEF ignorenl type typenames SEMI attendnl  */
#line 555 "gram.y"
                    { 
			DeclListPtr decl;

			for (decl = (yyvsp[-2].declList); decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol ((yyvsp[-6].publish), class_typedef,
							   (yyvsp[-3].type), decl->name);
			(yyval.expr) = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, (yyvsp[-2].declList), class_typedef, (yyvsp[-3].type), (yyvsp[-6].publish)), 0);
		    }
#line 3641 "gram.c"
    break;

  case 73: /* $@1: %empty  */
#line 564 "gram.y"
                    {
			SymbolPtr   symbol;
			Publish	    publish = (yyvsp[-3].publish);
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			(yyvsp[-2].namespace) = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, (yyvsp[0].atom), True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", (yyvsp[0].atom));
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", (yyvsp[0].atom));
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol ((yyvsp[-3].publish), class_namespace,
						     0, (yyvsp[0].atom));
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != (yyvsp[-2].namespace))
			    CurrentNamespace->publish = publish_public;
		    }
#line 3686 "gram.c"
    break;

  case 74: /* simple_statement: publish_extend NAMESPACE ignorenl namespacename $@1 OC statements CC attendnl  */
#line 605 "gram.y"
                    {
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != (yyvsp[-7].namespace))
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = (yyvsp[-7].namespace);
			(yyval.expr) = NewExprTree (NAMESPACE, NewExprAtom ((yyvsp[-5].atom), 0, False), (yyvsp[-2].expr));
		    }
#line 3704 "gram.c"
    break;

  case 75: /* simple_statement: opt_publish IMPORT ignorenl fullnames SEMI attendnl  */
#line 619 "gram.y"
                    {
			SymbolPtr	symbol;
			ExprPtr		p, e, n;

			p = (yyvsp[-2].expr);
			for (p = (yyvsp[-2].expr); p; p = n)
			{
			    if (p->base.tag == COMMA)
			    {
				e = p->tree.left;
				n = p->tree.right;
			    }
			    else
			    {
				e = p;
				n = 0;
			    }
			    if (e->base.tag == COLONCOLON)
				e = e->tree.right;
			    symbol = e->atom.symbol;
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", e->atom.atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", e->atom.atom);
				YYERROR;
			    }
			    NamespaceImport (CurrentNamespace, 
					     symbol->namespace.namespace, (yyvsp[-5].publish));
			}
			(yyval.expr) = NewExprTree (IMPORT, (yyvsp[-2].expr), NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   (yyvsp[-5].publish)));
		    }
#line 3748 "gram.c"
    break;

  case 76: /* simple_statement: try_statement attendnl  */
#line 659 "gram.y"
                    { (yyval.expr) = (yyvsp[-1].expr); }
#line 3754 "gram.c"
    break;

  case 77: /* simple_statement: TWIXT ignorenl namespace_start OP opt_expr SEMI opt_expr CP statement namespace_end attendnl  */
#line 661 "gram.y"
                    { (yyval.expr) = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, (yyvsp[-6].expr), (yyvsp[-4].expr)),
					NewExprTree (TWIXT, (yyvsp[-2].expr), 0));
		    }
#line 3763 "gram.c"
    break;

  case 78: /* for_exprs: opt_expr SEMI for_exprs  */
#line 667 "gram.y"
                    { (yyval.expr) = NewExprTree(SEMI, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 3769 "gram.c"
    break;

  case 79: /* for_exprs: opt_expr  */
#line 669 "gram.y"
                    { (yyval.expr) = NewExprTree(SEMI, (yyvsp[0].expr), 0); }
#line 3775 "gram.c"
    break;

  case 81: /* try_body_statement: OC statements CC  */
#line 674 "gram.y"
                    { (yyval.expr) = (yyvsp[-1].expr); }
#line 3781 "gram.c"
    break;

  case 82: /* try_statement: TRY ignorenl try_body_statement catches  */
#line 677 "gram.y"
                    { (yyval.expr) = NewExprTree (CATCH, (yyvsp[0].expr), (yyvsp[-1].expr)); }
#line 3787 "gram.c"
    break;

  case 83: /* catches: catches catch  */
#line 681 "gram.y"
                    { (yyval.expr) = NewExprTree (CATCH, (yyvsp[-1].expr), (yyvsp[0].expr)); }
#line 3793 "gram.c"
    break;

  case 84: /* catches: %empty  */
#line 683 "gram.y"
                    { (yyval.expr) = 0; }
#line 3799 "gram.c"
    break;

  case 85: /* catch: CATCH fullname namespace_start args doc_string block namespace_end  */
#line 686 "gram.y"
                    { (yyval.expr) = NewExprCode (NewFuncCode (typePrim[rep_void],
						     (yyvsp[-3].argType), (yyvsp[-1].expr), (yyvsp[-2].value)),
					(yyvsp[-5].expr)); 
		    }
#line 3808 "gram.c"
    break;

  case 87: /* opt_func_body: SEMI  */
#line 693 "gram.y"
                    { (yyval.expr) = 0; }
#line 3814 "gram.c"
    break;

  case 88: /* $@2: %empty  */
#line 695 "gram.y"
                  { ++funcDepth; }
#line 3820 "gram.c"
    break;

  case 89: /* func_body: $@2 block_or_expr  */
#line 695 "gram.y"
                                                 { --funcDepth; (yyval.expr) = (yyvsp[0].expr); }
#line 3826 "gram.c"
    break;

  case 90: /* block_or_expr: block  */
#line 698 "gram.y"
                    { (yyval.expr) = (yyvsp[0].expr); }
#line 3832 "gram.c"
    break;

  case 91: /* block_or_expr: attendnl ASSIGN simpleexpr SEMI  */
#line 700 "gram.y"
                    { 
			(yyval.expr) = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, (yyvsp[-1].expr)),
					  NewExprTree (OC, 0, 0));
		    }
#line 3842 "gram.c"
    break;

  case 94: /* see_comment: %empty  */
#line 710 "gram.y"
                    { seeComment = 1; }
#line 3848 "gram.c"
    break;

  case 95: /* doc_string: see_comment opt_comment  */
#line 713 "gram.y"
                    { seeComment = 0; (yyval.value) = (yyvsp[0].value); }
#line 3854 "gram.c"
    break;

  case 97: /* opt_comment: %empty  */
#line 717 "gram.y"
                    { (yyval.value) = Void; }
#line 3860 "gram.c"
    break;

  case 98: /* case_block: block_start cases block_end  */
#line 720 "gram.y"
                    { (yyval.expr) = (yyvsp[-1].expr); }
#line 3866 "gram.c"
    break;

  case 99: /* cases: case cases  */
#line 723 "gram.y"
                    { (yyval.expr) = NewExprTree (CASE, (yyvsp[-1].expr), (yyvsp[0].expr)); }
#line 3872 "gram.c"
    break;

  case 100: /* cases: %empty  */
#line 725 "gram.y"
                    { (yyval.expr) = 0; }
#line 3878 "gram.c"
    break;

  case 101: /* case: CASE expr COLON statements  */
#line 728 "gram.y"
                    { (yyval.expr) = NewExprTree (CASE, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 3884 "gram.c"
    break;

  case 102: /* case: DEFAULT COLON statements  */
#line 730 "gram.y"
                    { (yyval.expr) = NewExprTree (CASE, 0, (yyvsp[0].expr)); }
#line 3890 "gram.c"
    break;

  case 103: /* union_case_block: block_start union_cases block_end  */
#line 733 "gram.y"
                    { (yyval.expr) = (yyvsp[-1].expr); }
#line 3896 "gram.c"
    break;

  case 104: /* union_cases: union_case union_cases  */
#line 736 "gram.y"
                    { (yyval.expr) = NewExprTree (CASE, (yyvsp[-1].expr), (yyvsp[0].expr)); }
#line 3902 "gram.c"
    break;

  case 105: /* union_cases: %empty  */
#line 738 "gram.y"
                    { (yyval.expr) = 0; }
#line 3908 "gram.c"
    break;

  case 106: /* union_case: CASE namespace_start NAME opt_name COLON statements namespace_end  */
#line 741 "gram.y"
                    { 
			SymbolPtr   sym = (yyvsp[-3].symbol);
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			(yyval.expr) = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom ((yyvsp[-4].atom), 0, False),
						       name),
					  (yyvsp[-1].expr));
		    }
#line 3927 "gram.c"
    break;

  case 107: /* union_case: DEFAULT COLON statements  */
#line 756 "gram.y"
                    { (yyval.expr) = NewExprTree (CASE, 0, (yyvsp[0].expr)); }
#line 3933 "gram.c"
    break;

  case 108: /* opt_name: NAME  */
#line 759 "gram.y"
                    {
			(yyval.symbol) = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     (yyvsp[0].atom));
		    }
#line 3944 "gram.c"
    break;

  case 109: /* opt_name: %empty  */
#line 766 "gram.y"
                    { (yyval.symbol) = 0; }
#line 3950 "gram.c"
    break;

  case 110: /* atoms: NAME COMMA atoms  */
#line 772 "gram.y"
                    { (yyval.atomList) = NewAtomList ((yyvsp[0].atomList), (yyvsp[-2].atom)); }
#line 3956 "gram.c"
    break;

  case 111: /* atoms: NAME  */
#line 774 "gram.y"
                    { (yyval.atomList) = NewAtomList (0, (yyvsp[0].atom)); }
#line 3962 "gram.c"
    break;

  case 112: /* typenames: typename COMMA typenames  */
#line 777 "gram.y"
                    { (yyval.declList) = NewDeclList ((yyvsp[-2].atom), 0, (yyvsp[0].declList)); }
#line 3968 "gram.c"
    break;

  case 113: /* typenames: typename  */
#line 779 "gram.y"
                    { (yyval.declList) = NewDeclList ((yyvsp[0].atom), 0, 0); }
#line 3974 "gram.c"
    break;

  case 116: /* initnames: name opt_init next_decl initnames  */
#line 793 "gram.y"
                    { 
			if ((yyvsp[-3].symbol))
			{
			    (yyval.declList) = NewDeclList ((yyvsp[-3].symbol)->symbol.name, (yyvsp[-2].expr), (yyvsp[0].declList)); 
			    (yyval.declList)->symbol = (yyvsp[-3].symbol);
			}
			else
			    (yyval.declList) = (yyvsp[0].declList);
		    }
#line 3988 "gram.c"
    break;

  case 117: /* initnames: name opt_init  */
#line 803 "gram.y"
                    { 
			if ((yyvsp[-1].symbol))
			{
			    (yyval.declList) = NewDeclList ((yyvsp[-1].symbol)->symbol.name, (yyvsp[0].expr), 0);
			    (yyval.declList)->symbol = (yyvsp[-1].symbol);
			}
			else
			    (yyvsp[-1].symbol) = 0;
		    }
#line 4002 "gram.c"
    break;

  case 118: /* name: NAME  */
#line 814 "gram.y"
                    {	
			(yyval.symbol) = ParseNewSymbol ((yyvsp[-1].fulltype).publish,
					     (yyvsp[-1].fulltype).class,
					     (yyvsp[-1].fulltype).type,
					     (yyvsp[0].atom));
		    }
#line 4013 "gram.c"
    break;

  case 119: /* next_decl: COMMA  */
#line 826 "gram.y"
                    { (yyval.fulltype) = (yyvsp[(-2) - (1)].fulltype); }
#line 4019 "gram.c"
    break;

  case 120: /* func_decl: func_name namespace_start opt_argdefines CP  */
#line 832 "gram.y"
                    {
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc ((yyvsp[-3].funcDecl).type.type, (yyvsp[-1].argType));
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, (yyvsp[-3].funcDecl).decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    (yyvsp[-3].funcDecl).decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol ((yyvsp[-3].funcDecl).type.publish,
						     (yyvsp[-3].funcDecl).type.class, 
						     type,
						     (yyvsp[-3].funcDecl).decl->name);
			}
			CurrentNamespace = save;
			(yyval.funcDecl) = (yyvsp[-3].funcDecl);
			(yyval.funcDecl).decl->symbol = symbol;
			(yyval.funcDecl).type.type = type;
		    }
#line 4055 "gram.c"
    break;

  case 121: /* func_name: decl NAME OP  */
#line 865 "gram.y"
                    { (yyval.funcDecl).type = (yyvsp[-2].fulltype); (yyval.funcDecl).decl = NewDeclList ((yyvsp[-1].atom), 0, 0); }
#line 4061 "gram.c"
    break;

  case 122: /* func_name: decl FUNCTION NAME OP  */
#line 867 "gram.y"
                    { (yyval.funcDecl).type = (yyvsp[-3].fulltype); (yyval.funcDecl).decl = NewDeclList ((yyvsp[-1].atom), 0, 0); }
#line 4067 "gram.c"
    break;

  case 123: /* func_name: FUNCTION ignorenl NAME OP  */
#line 869 "gram.y"
                    { 
			(yyval.funcDecl).type.publish = publish_private;
			(yyval.funcDecl).type.class = class_undef;
			(yyval.funcDecl).type.type = typePoly;
			(yyval.funcDecl).decl = NewDeclList ((yyvsp[-1].atom), 0, 0); 
		    }
#line 4078 "gram.c"
    break;

  case 124: /* opt_init: ASSIGN simpleexpr  */
#line 877 "gram.y"
                    { (yyval.expr) = (yyvsp[0].expr); }
#line 4084 "gram.c"
    break;

  case 125: /* opt_init: ASSIGN init  */
#line 879 "gram.y"
                    { (yyval.expr) = (yyvsp[0].expr); }
#line 4090 "gram.c"
    break;

  case 126: /* opt_init: %empty  */
#line 881 "gram.y"
                    { (yyval.expr) = 0; }
#line 4096 "gram.c"
    break;

  case 127: /* decl: publish opt_class opt_type opt_nl  */
#line 887 "gram.y"
                    { (yyval.fulltype).publish = (yyvsp[-3].publish); (yyval.fulltype).class = (yyvsp[-2].class); (yyval.fulltype).type = (yyvsp[-1].type); }
#line 4102 "gram.c"
    break;

  case 128: /* decl: class opt_type opt_nl  */
#line 889 "gram.y"
                    { (yyval.fulltype).publish = publish_private; (yyval.fulltype).class = (yyvsp[-2].class); (yyval.fulltype).type = (yyvsp[-1].type); }
#line 4108 "gram.c"
    break;

  case 129: /* decl: type opt_nl  */
#line 891 "gram.y"
                    { (yyval.fulltype).publish = publish_private; (yyval.fulltype).class = class_undef; (yyval.fulltype).type = (yyvsp[-1].type); }
#line 4114 "gram.c"
    break;

  case 130: /* subscripts: opt_argdecls subscripts  */
#line 897 "gram.y"
                    { (yyval.type) = NewTypeFunc ((yyvsp[0].type), (yyvsp[-1].argType)); }
#line 4120 "gram.c"
    break;

  case 131: /* subscripts: OS opt_stars CS subscripts  */
#line 899 "gram.y"
                    { (yyval.type) = NewTypeArray ((yyvsp[0].type), (yyvsp[-2].expr), False); }
#line 4126 "gram.c"
    break;

  case 132: /* subscripts: OS dotdotdots CS subscripts  */
#line 901 "gram.y"
                    { (yyval.type) = NewTypeArray ((yyvsp[0].type), (yyvsp[-2].expr), True); }
#line 4132 "gram.c"
    break;

  case 133: /* subscripts: OS dims CS subscripts  */
#line 903 "gram.y"
                    { (yyval.type) = NewTypeArray ((yyvsp[0].type), (yyvsp[-2].expr), False); }
#line 4138 "gram.c"
    break;

  case 134: /* subscripts: OS type CS subscripts  */
#line 905 "gram.y"
                    { (yyval.type) = NewTypeHash ((yyvsp[0].type), (yyvsp[-2].type)); }
#line 4144 "gram.c"
    break;

  case 135: /* subscripts: %empty  */
#line 907 "gram.y"
                    { (yyval.type) = 0; }
#line 4150 "gram.c"
    break;

  case 136: /* type: subtype subscripts  */
#line 910 "gram.y"
                    {
			Type	*top = (yyvsp[0].type);
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = (yyvsp[-1].type);
			(yyval.type) = top;
		    }
#line 4182 "gram.c"
    break;

  case 137: /* type: TIMES type  */
#line 938 "gram.y"
                    { (yyval.type) = NewTypeRef ((yyvsp[0].type), True); }
#line 4188 "gram.c"
    break;

  case 138: /* type: STARSTAR type  */
#line 940 "gram.y"
                    { (yyval.type) = NewTypeRef (NewTypeRef ((yyvsp[0].type), True), True); }
#line 4194 "gram.c"
    break;

  case 139: /* type: AND type  */
#line 942 "gram.y"
                    { (yyval.type) = NewTypeRef (NewTypeRef ((yyvsp[0].type), False), False); }
#line 4200 "gram.c"
    break;

  case 140: /* type: LAND type  */
#line 944 "gram.y"
                    { (yyval.type) = NewTypeRef ((yyvsp[0].type), False); }
#line 4206 "gram.c"
    break;

  case 141: /* type: type PLUS type  */
#line 946 "gram.y"
                    { 
			if (ParseCanonType ((yyvsp[-2].type), False) != CanonTypeDefined)
			    YYERROR;
			if (ParseCanonType ((yyvsp[0].type), False) != CanonTypeDefined)
			    YYERROR;
			(yyval.type) = NewTypePlus ((yyvsp[-2].type), (yyvsp[0].type)); 
			if (!(yyval.type))
			    YYERROR;
		    }
#line 4220 "gram.c"
    break;

  case 143: /* subtype: STRUCT OC struct_members CC  */
#line 958 "gram.y"
                    {
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = (yyvsp[-1].memList); ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = (yyvsp[-1].memList); ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			(yyval.type) = NewTypeStruct (st);
		    }
#line 4250 "gram.c"
    break;

  case 144: /* subtype: UNION OC union_members CC  */
#line 984 "gram.y"
                    {
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = (yyvsp[-1].memList); ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = (yyvsp[-1].memList); ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			(yyval.type) = NewTypeUnion (st, False);
		    }
#line 4280 "gram.c"
    break;

  case 145: /* subtype: ENUM OC atoms CC  */
#line 1010 "gram.y"
                    {
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = (yyvsp[-1].atomList); al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = (yyvsp[-1].atomList); al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			(yyval.type) = NewTypeUnion (st, True);
		    }
#line 4304 "gram.c"
    break;

  case 146: /* subtype: OP type CP  */
#line 1031 "gram.y"
                    { (yyval.type) = (yyvsp[-1].type); }
#line 4310 "gram.c"
    break;

  case 147: /* subtype: fulltype  */
#line 1033 "gram.y"
                    { (yyval.type) = NewTypeName ((yyvsp[0].expr), 0); }
#line 4316 "gram.c"
    break;

  case 149: /* opt_type: %empty  */
#line 1037 "gram.y"
                    { (yyval.type) = typePoly; }
#line 4322 "gram.c"
    break;

  case 164: /* opt_stars: %empty  */
#line 1055 "gram.y"
                    { (yyval.expr) = 0; }
#line 4328 "gram.c"
    break;

  case 165: /* stars: stars COMMA TIMES  */
#line 1058 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[-2].expr)); }
#line 4334 "gram.c"
    break;

  case 166: /* stars: TIMES  */
#line 1060 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, 0, 0); }
#line 4340 "gram.c"
    break;

  case 167: /* dotdotdots: dotdotdots COMMA DOTDOTDOT  */
#line 1063 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[-2].expr)); }
#line 4346 "gram.c"
    break;

  case 168: /* dotdotdots: DOTDOTDOT  */
#line 1065 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, 0, 0); }
#line 4352 "gram.c"
    break;

  case 169: /* dims: simpleexpr COMMA dims  */
#line 1068 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4358 "gram.c"
    break;

  case 170: /* dims: simpleexpr  */
#line 1070 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[0].expr), 0); }
#line 4364 "gram.c"
    break;

  case 171: /* struct_members: opt_type atoms SEMI struct_members  */
#line 1076 "gram.y"
                    { (yyval.memList) = NewMemList ((yyvsp[-2].atomList), (yyvsp[-3].type), (yyvsp[0].memList)); }
#line 4370 "gram.c"
    break;

  case 172: /* struct_members: %empty  */
#line 1078 "gram.y"
                    { (yyval.memList) = 0; }
#line 4376 "gram.c"
    break;

  case 173: /* union_members: opt_type atoms SEMI union_members  */
#line 1081 "gram.y"
                    { (yyval.memList) = NewMemList ((yyvsp[-2].atomList), (yyvsp[-3].type), (yyvsp[0].memList)); }
#line 4382 "gram.c"
    break;

  case 174: /* union_members: %empty  */
#line 1083 "gram.y"
                    { (yyval.memList) = 0; }
#line 4388 "gram.c"
    break;

  case 176: /* opt_class: %empty  */
#line 1090 "gram.y"
                    { (yyval.class) = class_undef; }
#line 4394 "gram.c"
    break;

  case 182: /* opt_publish: %empty  */
#line 1099 "gram.y"
                    { (yyval.publish) = publish_private; }
#line 4400 "gram.c"
    break;

  case 187: /* opt_argdecls: OP argdecls CP  */
#line 1113 "gram.y"
                    { (yyval.argType) = (yyvsp[-1].argType); }
#line 4406 "gram.c"
    break;

  case 188: /* opt_argdecls: OP CP  */
#line 1115 "gram.y"
                    { (yyval.argType) = 0; }
#line 4412 "gram.c"
    break;

  case 189: /* argdecls: argdecl COMMA argdecls  */
#line 1118 "gram.y"
                    { (yyval.argType) = NewArgType ((yyvsp[-2].argDecl).type, False, (yyvsp[-2].argDecl).name, 0, (yyvsp[0].argType)); }
#line 4418 "gram.c"
    break;

  case 190: /* argdecls: argdecl opt_dotdotdot  */
#line 1120 "gram.y"
                    { (yyval.argType) = NewArgType ((yyvsp[-1].argDecl).type, (yyvsp[0].bool), (yyvsp[-1].argDecl).name, 0, 0); }
#line 4424 "gram.c"
    break;

  case 191: /* argdecl: type NAME  */
#line 1123 "gram.y"
                    { 
			ParseCanonType ((yyvsp[-1].type), False);
			(yyval.argDecl).type = (yyvsp[-1].type); 
			(yyval.argDecl).name = (yyvsp[0].atom); 
		    }
#line 4434 "gram.c"
    break;

  case 192: /* argdecl: type  */
#line 1129 "gram.y"
                    { 
			ParseCanonType ((yyvsp[0].type), False);
			(yyval.argDecl).type = (yyvsp[0].type);
			(yyval.argDecl).name = 0; 
		    }
#line 4444 "gram.c"
    break;

  case 193: /* args: OP opt_argdefines CP  */
#line 1140 "gram.y"
                    { (yyval.argType) = (yyvsp[-1].argType); }
#line 4450 "gram.c"
    break;

  case 194: /* opt_argdefines: ignorenl argdefines  */
#line 1143 "gram.y"
                    {
			ArgType	*args;
			Type	*type;

			for (args = (yyvsp[0].argType); args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0),
						     False);
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			(yyval.argType) = (yyvsp[0].argType);
		    }
#line 4479 "gram.c"
    break;

  case 195: /* opt_argdefines: ignorenl  */
#line 1168 "gram.y"
                    { (yyval.argType) = 0; }
#line 4485 "gram.c"
    break;

  case 196: /* argdefines: argdefine COMMA argdefines  */
#line 1171 "gram.y"
                    { (yyval.argType) = NewArgType ((yyvsp[-2].argDecl).type, False, (yyvsp[-2].argDecl).name, 0, (yyvsp[0].argType)); }
#line 4491 "gram.c"
    break;

  case 197: /* argdefines: argdefine opt_dotdotdot  */
#line 1173 "gram.y"
                    { (yyval.argType) = NewArgType ((yyvsp[-1].argDecl).type, (yyvsp[0].bool), (yyvsp[-1].argDecl).name, 0, 0); }
#line 4497 "gram.c"
    break;

  case 198: /* argdefine: opt_type NAME  */
#line 1176 "gram.y"
                    { (yyval.argDecl).type = (yyvsp[-1].type); (yyval.argDecl).name = (yyvsp[0].atom); }
#line 4503 "gram.c"
    break;

  case 199: /* argdefine: type  */
#line 1178 "gram.y"
                    { (yyval.argDecl).type = (yyvsp[0].type); (yyval.argDecl).name = 0; }
#line 4509 "gram.c"
    break;

  case 200: /* opt_dotdotdot: DOTDOTDOT  */
#line 1181 "gram.y"
                    { (yyval.bool) = True; }
#line 4515 "gram.c"
    break;

  case 201: /* opt_dotdotdot: %empty  */
#line 1183 "gram.y"
                    { (yyval.bool) = False; }
#line 4521 "gram.c"
    break;

  case 203: /* opt_expr: %empty  */
#line 1191 "gram.y"
                    { (yyval.expr) = 0; }
#line 4527 "gram.c"
    break;

  case 205: /* expr: decl initnames  */
#line 1195 "gram.y"
                    { 
			DeclList    *decl;

			for (decl = (yyvsp[0].declList); decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = (yyvsp[-1].fulltype).type;
			    }
			}

			(yyval.expr) = NewExprDecl (VAR, (yyvsp[0].declList), (yyvsp[-1].fulltype).class, (yyvsp[-1].fulltype).type, (yyvsp[-1].fulltype).publish); 
		    }
#line 4546 "gram.c"
    break;

  case 207: /* comma_expr: comma_expr COMMA simpleexpr  */
#line 1212 "gram.y"
                    { (yyval.expr) = NewExprTree(COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4552 "gram.c"
    break;

  case 209: /* opt_exprs: %empty  */
#line 1219 "gram.y"
                    { (yyval.expr) = 0; }
#line 4558 "gram.c"
    break;

  case 210: /* exprs: simpleexpr COMMA exprs  */
#line 1222 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4564 "gram.c"
    break;

  case 211: /* exprs: simpleexpr  */
#line 1224 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[0].expr), 0); }
#line 4570 "gram.c"
    break;

  case 213: /* opt_actuals: %empty  */
#line 1228 "gram.y"
                    { (yyval.expr) = 0; }
#line 4576 "gram.c"
    break;

  case 214: /* actuals: simpleexpr COMMA actuals  */
#line 1231 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4582 "gram.c"
    break;

  case 215: /* actuals: simpleexpr opt_dotdotdot  */
#line 1233 "gram.y"
                    {	
			ExprPtr	arg = (yyvsp[0].bool) ? NewExprTree (DOTDOTDOT, (yyvsp[-1].expr), 0) : (yyvsp[-1].expr);
			(yyval.expr) = NewExprTree (COMMA, arg, 0); 
		    }
#line 4591 "gram.c"
    break;

  case 216: /* func_right: attendnl ASSIGN simpleexpr  */
#line 1239 "gram.y"
                    { 
			(yyval.expr) = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, (yyvsp[0].expr)),
					  NewExprTree (OC, 0, 0));
		    }
#line 4601 "gram.c"
    break;

  case 217: /* $@3: %empty  */
#line 1244 "gram.y"
                  { ++funcDepth; }
#line 4607 "gram.c"
    break;

  case 218: /* func_right: $@3 block  */
#line 1244 "gram.y"
                                         { --funcDepth; (yyval.expr) = (yyvsp[0].expr); }
#line 4613 "gram.c"
    break;

  case 219: /* simpleexpr: simpleexpr assignop simpleexpr  */
#line 1250 "gram.y"
                    { 
			if ((yyvsp[-1].ints) == ASSIGNPOW)
			    (yyval.expr) = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, (yyvsp[-2].expr), (yyvsp[0].expr)));
			else
			{
			    ExprPtr left = (yyvsp[-2].expr);
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if ((yyvsp[-1].ints) == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				(yyvsp[-2].expr)->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  (yyvsp[-2].expr)->atom.atom);
			    }
			    (yyval.expr) = NewExprTree((yyvsp[-1].ints), (yyvsp[-2].expr), (yyvsp[0].expr)); 
			}
		    }
#line 4643 "gram.c"
    break;

  case 220: /* simpleexpr: opt_type FUNC namespace_start args doc_string func_right namespace_end  */
#line 1276 "gram.y"
                    {
			ParseCanonType ((yyvsp[-6].type), False);
			(yyval.expr) = NewExprCode (NewFuncCode ((yyvsp[-6].type), (yyvsp[-3].argType), (yyvsp[-1].expr), (yyvsp[-2].value)), 0); 
		    }
#line 4652 "gram.c"
    break;

  case 221: /* simpleexpr: MOD integer  */
#line 1281 "gram.y"
                    {   Value	t;
			t = do_Thread_id_to_thread ((yyvsp[0].value));
			if (t == Void)
			{
			    ParseError ("No thread %v", (yyvsp[0].value));
			    YYERROR;
			}
			else
			    (yyval.expr) = NewExprConst(THREAD_CONST, t); 
		    }
#line 4667 "gram.c"
    break;

  case 222: /* simpleexpr: TIMES simpleexpr  */
#line 1292 "gram.y"
                    { (yyval.expr) = NewExprTree(STAR, (yyvsp[0].expr), (Expr *) 0); }
#line 4673 "gram.c"
    break;

  case 223: /* simpleexpr: STARSTAR simpleexpr  */
#line 1294 "gram.y"
                    { (yyval.expr) = NewExprTree(STAR, NewExprTree (STAR, (yyvsp[0].expr), 0), 0); }
#line 4679 "gram.c"
    break;

  case 224: /* simpleexpr: LAND simpleexpr  */
#line 1296 "gram.y"
                    { (yyval.expr) = NewExprTree(AMPER, (yyvsp[0].expr), (Expr *) 0); }
#line 4685 "gram.c"
    break;

  case 225: /* simpleexpr: AND simpleexpr  */
#line 1298 "gram.y"
                    { (yyval.expr) = NewExprTree(AMPER, 
				       NewExprTree (AMPER, (yyvsp[0].expr), (Expr *) 0), 
				       (Expr *) 0); }
#line 4693 "gram.c"
    break;

  case 226: /* simpleexpr: MINUS simpleexpr  */
#line 1302 "gram.y"
                    { (yyval.expr) = NewExprTree(UMINUS, (yyvsp[0].expr), (Expr *) 0); }
#line 4699 "gram.c"
    break;

  case 227: /* simpleexpr: LNOT simpleexpr  */
#line 1304 "gram.y"
                    { (yyval.expr) = NewExprTree(LNOT, (yyvsp[0].expr), (Expr *) 0); }
#line 4705 "gram.c"
    break;

  case 228: /* simpleexpr: BANG simpleexpr  */
#line 1306 "gram.y"
                    { (yyval.expr) = NewExprTree(BANG, (yyvsp[0].expr), (Expr *) 0); }
#line 4711 "gram.c"
    break;

  case 229: /* simpleexpr: simpleexpr BANG  */
#line 1308 "gram.y"
                    { 
			(yyval.expr) = NewExprTree(FACT, 
					 BuildName ("Math", "factorial"),
					 (yyvsp[-1].expr));
		    }
#line 4721 "gram.c"
    break;

  case 230: /* simpleexpr: INC simpleexpr  */
#line 1314 "gram.y"
                    { (yyval.expr) = NewExprTree(INC, (yyvsp[0].expr), (Expr *) 0); }
#line 4727 "gram.c"
    break;

  case 231: /* simpleexpr: simpleexpr INC  */
#line 1316 "gram.y"
                    { (yyval.expr) = NewExprTree(INC, (Expr *) 0, (yyvsp[-1].expr)); }
#line 4733 "gram.c"
    break;

  case 232: /* simpleexpr: DEC simpleexpr  */
#line 1318 "gram.y"
                    { (yyval.expr) = NewExprTree(DEC, (yyvsp[0].expr), (Expr *) 0); }
#line 4739 "gram.c"
    break;

  case 233: /* simpleexpr: simpleexpr DEC  */
#line 1320 "gram.y"
                    { (yyval.expr) = NewExprTree(DEC, (Expr *) 0, (yyvsp[-1].expr)); }
#line 4745 "gram.c"
    break;

  case 234: /* simpleexpr: FORK simpleexpr  */
#line 1322 "gram.y"
                    { (yyval.expr) = NewExprTree (FORK, (Expr *) 0, (yyvsp[0].expr)); }
#line 4751 "gram.c"
    break;

  case 235: /* simpleexpr: simpleexpr PLUS simpleexpr  */
#line 1324 "gram.y"
                    { (yyval.expr) = NewExprTree(PLUS, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4757 "gram.c"
    break;

  case 236: /* simpleexpr: simpleexpr MINUS simpleexpr  */
#line 1326 "gram.y"
                    { (yyval.expr) = NewExprTree(MINUS, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4763 "gram.c"
    break;

  case 237: /* simpleexpr: simpleexpr TIMES simpleexpr  */
#line 1328 "gram.y"
                    { (yyval.expr) = NewExprTree(TIMES, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4769 "gram.c"
    break;

  case 238: /* simpleexpr: simpleexpr DIVIDE simpleexpr  */
#line 1330 "gram.y"
                    { (yyval.expr) = NewExprTree(DIVIDE, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4775 "gram.c"
    break;

  case 239: /* simpleexpr: simpleexpr DIV simpleexpr  */
#line 1332 "gram.y"
                    { (yyval.expr) = NewExprTree(DIV, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4781 "gram.c"
    break;

  case 240: /* simpleexpr: simpleexpr MOD simpleexpr  */
#line 1334 "gram.y"
                    { (yyval.expr) = NewExprTree(MOD, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4787 "gram.c"
    break;

  case 241: /* simpleexpr: simpleexpr STARSTAR simpleexpr  */
#line 1336 "gram.y"
                    { 
			(yyval.expr) = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, (yyvsp[-2].expr), (yyvsp[0].expr))); 
		    }
#line 4797 "gram.c"
    break;

  case 242: /* simpleexpr: simpleexpr POW2  */
#line 1342 "gram.y"
                    {
			(yyval.expr) = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, (yyvsp[-1].expr),
						       NewExprConst (TEN_NUM,
								     NewInt(2))));
		    }
#line 4809 "gram.c"
    break;

  case 243: /* simpleexpr: simpleexpr POW3  */
#line 1350 "gram.y"
                    {
			(yyval.expr) = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, (yyvsp[-1].expr),
						       NewExprConst (TEN_NUM,
								     NewInt(3))));
		    }
#line 4821 "gram.c"
    break;

  case 244: /* simpleexpr: simpleexpr SHIFTL simpleexpr  */
#line 1358 "gram.y"
                    { (yyval.expr) = NewExprTree(SHIFTL, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4827 "gram.c"
    break;

  case 245: /* simpleexpr: simpleexpr SHIFTR simpleexpr  */
#line 1360 "gram.y"
                    { (yyval.expr) = NewExprTree(SHIFTR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4833 "gram.c"
    break;

  case 246: /* simpleexpr: simpleexpr QUEST simpleexpr COLON simpleexpr  */
#line 1362 "gram.y"
                    { (yyval.expr) = NewExprTree(QUEST, (yyvsp[-4].expr), NewExprTree(COLON, (yyvsp[-2].expr), (yyvsp[0].expr))); }
#line 4839 "gram.c"
    break;

  case 247: /* simpleexpr: simpleexpr LXOR simpleexpr  */
#line 1364 "gram.y"
                    { (yyval.expr) = NewExprTree(LXOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4845 "gram.c"
    break;

  case 248: /* simpleexpr: simpleexpr LAND simpleexpr  */
#line 1366 "gram.y"
                    { (yyval.expr) = NewExprTree(LAND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4851 "gram.c"
    break;

  case 249: /* simpleexpr: simpleexpr LOR simpleexpr  */
#line 1368 "gram.y"
                    { (yyval.expr) = NewExprTree(LOR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4857 "gram.c"
    break;

  case 250: /* simpleexpr: simpleexpr AND simpleexpr  */
#line 1370 "gram.y"
                    { (yyval.expr) = NewExprTree(AND, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4863 "gram.c"
    break;

  case 251: /* simpleexpr: simpleexpr OR simpleexpr  */
#line 1372 "gram.y"
                    { (yyval.expr) = NewExprTree(OR, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4869 "gram.c"
    break;

  case 252: /* simpleexpr: simpleexpr EQ simpleexpr  */
#line 1374 "gram.y"
                    { (yyval.expr) = NewExprTree(EQ, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4875 "gram.c"
    break;

  case 253: /* simpleexpr: simpleexpr NE simpleexpr  */
#line 1376 "gram.y"
                    { (yyval.expr) = NewExprTree(NE, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4881 "gram.c"
    break;

  case 254: /* simpleexpr: simpleexpr LT simpleexpr  */
#line 1378 "gram.y"
                    { (yyval.expr) = NewExprTree(LT, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4887 "gram.c"
    break;

  case 255: /* simpleexpr: simpleexpr GT simpleexpr  */
#line 1380 "gram.y"
                    { (yyval.expr) = NewExprTree(GT, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4893 "gram.c"
    break;

  case 256: /* simpleexpr: simpleexpr LE simpleexpr  */
#line 1382 "gram.y"
                    { (yyval.expr) = NewExprTree(LE, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4899 "gram.c"
    break;

  case 257: /* simpleexpr: simpleexpr GE simpleexpr  */
#line 1384 "gram.y"
                    { (yyval.expr) = NewExprTree(GE, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 4905 "gram.c"
    break;

  case 259: /* simpleexpr: TEN_NUM  */
#line 1387 "gram.y"
                    { (yyval.expr) = NewExprConst(TEN_NUM, (yyvsp[0].value)); }
#line 4911 "gram.c"
    break;

  case 260: /* simpleexpr: OCTAL_NUM  */
#line 1389 "gram.y"
                    { (yyval.expr) = NewExprConst(OCTAL_NUM, (yyvsp[0].value)); }
#line 4917 "gram.c"
    break;

  case 261: /* simpleexpr: OCTAL0_NUM  */
#line 1391 "gram.y"
                    { (yyval.expr) = NewExprConst(OCTAL0_NUM, (yyvsp[0].value)); }
#line 4923 "gram.c"
    break;

  case 262: /* simpleexpr: BINARY_NUM  */
#line 1393 "gram.y"
                    { (yyval.expr) = NewExprConst(BINARY_NUM, (yyvsp[0].value)); }
#line 4929 "gram.c"
    break;

  case 263: /* simpleexpr: HEX_NUM  */
#line 1395 "gram.y"
                    { (yyval.expr) = NewExprConst(HEX_NUM, (yyvsp[0].value)); }
#line 4935 "gram.c"
    break;

  case 264: /* simpleexpr: TEN_FLOAT  */
#line 1397 "gram.y"
                    { (yyval.expr) = NewExprConst(TEN_FLOAT, (yyvsp[0].value)); }
#line 4941 "gram.c"
    break;

  case 265: /* simpleexpr: OCTAL_FLOAT  */
#line 1399 "gram.y"
                    { (yyval.expr) = NewExprConst(OCTAL_FLOAT, (yyvsp[0].value)); }
#line 4947 "gram.c"
    break;

  case 266: /* simpleexpr: OCTAL0_FLOAT  */
#line 1401 "gram.y"
                    { (yyval.expr) = NewExprConst(OCTAL0_FLOAT, (yyvsp[0].value)); }
#line 4953 "gram.c"
    break;

  case 267: /* simpleexpr: BINARY_FLOAT  */
#line 1403 "gram.y"
                    { (yyval.expr) = NewExprConst(BINARY_FLOAT, (yyvsp[0].value)); }
#line 4959 "gram.c"
    break;

  case 268: /* simpleexpr: HEX_FLOAT  */
#line 1405 "gram.y"
                    { (yyval.expr) = NewExprConst(HEX_FLOAT, (yyvsp[0].value)); }
#line 4965 "gram.c"
    break;

  case 269: /* simpleexpr: CHAR_CONST  */
#line 1407 "gram.y"
                    { (yyval.expr) = NewExprConst(CHAR_CONST, (yyvsp[0].value)); }
#line 4971 "gram.c"
    break;

  case 270: /* simpleexpr: STRING_CONST  */
#line 1409 "gram.y"
                    { (yyval.expr) = NewExprConst(STRING_CONST, (yyvsp[0].value)); }
#line 4977 "gram.c"
    break;

  case 271: /* simpleexpr: VOIDVAL  */
#line 1411 "gram.y"
                    { (yyval.expr) = NewExprConst(VOIDVAL, (yyvsp[0].value)); }
#line 4983 "gram.c"
    break;

  case 272: /* simpleexpr: BOOLVAL  */
#line 1413 "gram.y"
                    { (yyval.expr) = NewExprConst(BOOLVAL, (yyvsp[0].value)); }
#line 4989 "gram.c"
    break;

  case 273: /* simpleexpr: OS CS  */
#line 1415 "gram.y"
                    { 
			(yyval.expr) = BuildFullname (0, AtomId ("[]"));
		    }
#line 4997 "gram.c"
    break;

  case 274: /* simpleexpr: OP type CP namespace_start init namespace_end  */
#line 1419 "gram.y"
                    { 
			ParseCanonType ((yyvsp[-4].type), False);
			if ((yyvsp[-1].expr))
			    (yyvsp[-1].expr)->base.type = (yyvsp[-4].type);
			(yyval.expr) = NewExprTree (NEW, (yyvsp[-1].expr), 0);
			(yyval.expr)->base.type = (yyvsp[-4].type);
		    }
#line 5009 "gram.c"
    break;

  case 275: /* simpleexpr: OP OS stars CS CP namespace_start arrayinit namespace_end  */
#line 1427 "gram.y"
                    { 
			(yyvsp[-1].expr)->base.type = NewTypeArray (typePoly, (yyvsp[-5].expr), True); 
			ParseCanonType ((yyvsp[-1].expr)->base.type, False);
			(yyval.expr) = NewExprTree (NEW, (yyvsp[-1].expr), 0); 
			(yyval.expr)->base.type = (yyvsp[-1].expr)->base.type;
		    }
#line 5020 "gram.c"
    break;

  case 276: /* simpleexpr: OP OS dims CS CP namespace_start opt_arrayinit namespace_end  */
#line 1434 "gram.y"
                    { 
			TypePtr	t = NewTypeArray (typePoly, (yyvsp[-5].expr), False);
			ParseCanonType (t, False);
			(yyval.expr) = NewExprTree (NEW, (yyvsp[-1].expr), 0); 
			if ((yyvsp[-1].expr))
			    (yyvsp[-1].expr)->base.type = t;
			(yyval.expr)->base.type = t;
		    }
#line 5033 "gram.c"
    break;

  case 277: /* simpleexpr: OP OS type CS CP namespace_start opt_hashinit namespace_end  */
#line 1443 "gram.y"
                    {
			TypePtr t = NewTypeHash (typePoly, (yyvsp[-5].type));
			ParseCanonType (t, False);
			(yyval.expr) = NewExprTree (NEW, (yyvsp[-1].expr), 0);
			if ((yyvsp[-1].expr))
			    (yyvsp[-1].expr)->base.type = t;
			(yyval.expr)->base.type = t;
		    }
#line 5046 "gram.c"
    break;

  case 278: /* simpleexpr: type DOT NAME  */
#line 1452 "gram.y"
                    {
			ParseCanonType ((yyvsp[-2].type), False);
			(yyval.expr) = NewExprTree (UNION, NewExprAtom ((yyvsp[0].atom), 0, False), 0); 
			(yyval.expr)->base.type = (yyvsp[-2].type);
		    }
#line 5056 "gram.c"
    break;

  case 279: /* simpleexpr: OP type DOT NAME CP simpleexpr  */
#line 1458 "gram.y"
                    { 
			ParseCanonType ((yyvsp[-4].type), False);
			(yyval.expr) = NewExprTree (UNION, NewExprAtom ((yyvsp[-2].atom), 0, False), (yyvsp[0].expr)); 
			(yyval.expr)->base.type = (yyvsp[-4].type);
		    }
#line 5066 "gram.c"
    break;

  case 280: /* simpleexpr: DOLLAR opt_integer  */
#line 1464 "gram.y"
                    { (yyval.expr) = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, (yyvsp[0].value))); }
#line 5072 "gram.c"
    break;

  case 281: /* simpleexpr: DOT  */
#line 1466 "gram.y"
                    { (yyval.expr) = NewExprTree (DOLLAR, 0, 0); }
#line 5078 "gram.c"
    break;

  case 282: /* simpleexpr: OP expr CP  */
#line 1468 "gram.y"
                    { (yyval.expr) = (yyvsp[-1].expr); }
#line 5084 "gram.c"
    break;

  case 283: /* simpleexpr: OP block CP  */
#line 1470 "gram.y"
                    { (yyval.expr) = (yyvsp[-1].expr); }
#line 5090 "gram.c"
    break;

  case 284: /* simpleexpr: simpleexpr STAROS dims CS  */
#line 1472 "gram.y"
                    { (yyval.expr) = NewExprTree (OS, NewExprTree (STAR, (yyvsp[-3].expr), (Expr *) 0), (yyvsp[-1].expr)); }
#line 5096 "gram.c"
    break;

  case 285: /* simpleexpr: simpleexpr OS dims CS  */
#line 1474 "gram.y"
                    { (yyval.expr) = NewExprTree(OS, (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 5102 "gram.c"
    break;

  case 286: /* simpleexpr: simpleexpr OP opt_actuals CP  */
#line 1476 "gram.y"
                    { (yyval.expr) = NewExprTree (OP, (yyvsp[-3].expr), (yyvsp[-1].expr)); }
#line 5108 "gram.c"
    break;

  case 287: /* simpleexpr: ISTYPE OP simpleexpr COMMA type CP  */
#line 1478 "gram.y"
                    {
			TypePtr	type = (yyvsp[-1].type);
			ParseCanonType (type, False);
			(yyval.expr) = NewExprType (ISTYPE, (yyvsp[-3].expr), type);
		    }
#line 5118 "gram.c"
    break;

  case 288: /* simpleexpr: HASMEMBER OP simpleexpr COMMA NAME CP  */
#line 1484 "gram.y"
                    { (yyval.expr) = NewExprTree (HASMEMBER, (yyvsp[-3].expr), NewExprAtom((yyvsp[-1].atom), 0, False)); }
#line 5124 "gram.c"
    break;

  case 289: /* simpleexpr: simpleexpr DOT NAME  */
#line 1486 "gram.y"
                    { (yyval.expr) = NewExprTree(DOT, (yyvsp[-2].expr), NewExprAtom ((yyvsp[0].atom), 0, False)); }
#line 5130 "gram.c"
    break;

  case 290: /* simpleexpr: simpleexpr ARROW NAME  */
#line 1488 "gram.y"
                    { (yyval.expr) = NewExprTree(ARROW, (yyvsp[-2].expr), NewExprAtom ((yyvsp[0].atom), 0, False)); }
#line 5136 "gram.c"
    break;

  case 292: /* opt_integer: %empty  */
#line 1492 "gram.y"
                    { (yyval.value) = Zero; }
#line 5142 "gram.c"
    break;

  case 314: /* opt_arrayinit: OC CC  */
#line 1520 "gram.y"
                    { (yyval.expr) = 0; }
#line 5148 "gram.c"
    break;

  case 315: /* opt_arrayinit: %empty  */
#line 1522 "gram.y"
                    { (yyval.expr) = 0; }
#line 5154 "gram.c"
    break;

  case 316: /* arrayinit: OC arrayelts opt_comma opt_dotdotdot CC  */
#line 1525 "gram.y"
                    { 
			ExprPtr	elts = (yyvsp[-3].expr) ? ExprRehang ((yyvsp[-3].expr), 0) : 0;
			if ((yyvsp[-1].bool))
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTDOTDOT, 0, 0),
							 0);
			}
			(yyval.expr) = NewExprTree (ARRAY, elts, 0); 
		    }
#line 5172 "gram.c"
    break;

  case 317: /* arrayinit: OC OS namespace_start compnames comparray CS comprehension namespace_end CC  */
#line 1539 "gram.y"
                    {
			(yyval.expr) = NewExprTree (COMP, NewExprTree (COMP, (yyvsp[-5].expr), (yyvsp[-4].expr)), (yyvsp[-2].expr));
		    }
#line 5180 "gram.c"
    break;

  case 318: /* comprehension: ASSIGN arrayelt  */
#line 1544 "gram.y"
                    { (yyval.expr) = (yyvsp[0].expr); }
#line 5186 "gram.c"
    break;

  case 320: /* compnames: compname COMMA compnames  */
#line 1548 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5192 "gram.c"
    break;

  case 322: /* compname: NAME  */
#line 1552 "gram.y"
                    { 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], (yyvsp[0].atom));
			(yyval.expr) = NewExprAtom ((yyvsp[0].atom), s, False); 
		    }
#line 5203 "gram.c"
    break;

  case 323: /* comparray: %empty  */
#line 1560 "gram.y"
                    {
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			(yyval.expr) = NewExprAtom (a, s, False);
		    }
#line 5215 "gram.c"
    break;

  case 324: /* arrayelts: arrayelts COMMA arrayelt  */
#line 1569 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5221 "gram.c"
    break;

  case 325: /* arrayelts: arrayelt  */
#line 1571 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[0].expr)); }
#line 5227 "gram.c"
    break;

  case 329: /* opt_hashinit: OC CC  */
#line 1582 "gram.y"
                    { (yyval.expr) = 0; }
#line 5233 "gram.c"
    break;

  case 330: /* opt_hashinit: %empty  */
#line 1584 "gram.y"
                    { (yyval.expr) = 0; }
#line 5239 "gram.c"
    break;

  case 331: /* hashinit: OC hashelts opt_comma CC  */
#line 1587 "gram.y"
                    {
			ExprPtr elts = (yyvsp[-2].expr) ? ExprRehang ((yyvsp[-2].expr), 0) : 0;
			(yyval.expr) = NewExprTree (HASH, elts, 0);
		    }
#line 5248 "gram.c"
    break;

  case 332: /* hashelts: hashelts COMMA hashelt  */
#line 1593 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5254 "gram.c"
    break;

  case 333: /* hashelts: hashelt  */
#line 1595 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[0].expr)); }
#line 5260 "gram.c"
    break;

  case 334: /* hashelt: simpleexpr DARROW hashvalue  */
#line 1598 "gram.y"
                    { (yyval.expr) = NewExprTree (DARROW, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5266 "gram.c"
    break;

  case 335: /* hashelt: DARROW hashvalue  */
#line 1600 "gram.y"
                    { (yyval.expr) = NewExprTree (DARROW, 0, (yyvsp[0].expr)); }
#line 5272 "gram.c"
    break;

  case 338: /* structinit: OC structelts opt_comma CC  */
#line 1609 "gram.y"
                    { (yyval.expr) = NewExprTree (STRUCT, ExprRehang ((yyvsp[-2].expr), 0), 0); }
#line 5278 "gram.c"
    break;

  case 339: /* structelts: structelts COMMA structelt  */
#line 1612 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, (yyvsp[-2].expr), (yyvsp[0].expr)); }
#line 5284 "gram.c"
    break;

  case 340: /* structelts: structelt  */
#line 1614 "gram.y"
                    { (yyval.expr) = NewExprTree (COMMA, 0, (yyvsp[0].expr)); }
#line 5290 "gram.c"
    break;

  case 341: /* structelt: NAME ASSIGN simpleexpr  */
#line 1617 "gram.y"
                    { (yyval.expr) = NewExprTree (ASSIGN, NewExprAtom ((yyvsp[-2].atom), 0, False), (yyvsp[0].expr)); }
#line 5296 "gram.c"
    break;

  case 342: /* structelt: NAME ASSIGN init  */
#line 1619 "gram.y"
                    { (yyval.expr) = NewExprTree (ASSIGN, NewExprAtom ((yyvsp[-2].atom), 0, False), (yyvsp[0].expr)); }
#line 5302 "gram.c"
    break;

  case 343: /* structelt: DOT NAME ASSIGN simpleexpr  */
#line 1621 "gram.y"
                    { (yyval.expr) = NewExprTree (ASSIGN, NewExprAtom ((yyvsp[-2].atom), 0, False), (yyvsp[0].expr)); }
#line 5308 "gram.c"
    break;

  case 344: /* structelt: DOT NAME ASSIGN init  */
#line 1623 "gram.y"
                    { (yyval.expr) = NewExprTree (ASSIGN, NewExprAtom ((yyvsp[-2].atom), 0, False), (yyvsp[0].expr)); }
#line 5314 "gram.c"
    break;

  case 348: /* init: OC CC  */
#line 1629 "gram.y"
                    { (yyval.expr) = NewExprTree (ANONINIT, 0, 0); }
#line 5320 "gram.c"
    break;


#line 5324 "gram.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 1631 "gram.y"


static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp, CodePtr *cp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
    if (CurrentFrame)
	*cp = CurrentFrame->function->func.code;
    else
	*cp = 0;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    ArrayValueSet (&array->array, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	ArrayValueSet (&array->array, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk for() loop arguments and normalize the list
 */
static Expr *
ParseCanonFor (Expr *expr)
{
    if (!expr || !expr->tree.right) {
        ParseError ("Too few exprs in for()\n");
        return 0;
    }
    if (!expr->tree.right->tree.right) {
        /* 2-argument for() */
        expr = NewExprTree(FOR, 0, expr);
    }
    if (expr->tree.right->tree.right->tree.right) {
        ParseError ("Too many exprs in for()\n");
        return 0;
    }
    return expr;
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;

    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return CanonTypeUndefined;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type, Void);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ignorenl = 0;
    ParseError ("%s before %S", msg, yytext);
}
